#!/usr/bin/perl

foreach $filename (@ARGV) {
	if(-e $filename) {
		$shouldModify = 0;

		open(INPUT, "$filename") || die "Cannot open $filename for reading\n";
		while($line = <INPUT>) {
			if($line =~ /\r/) {
				$shouldModify = 1;
				last;
			}
		}
		close(INPUT);

		if($shouldModify) {
			print "File: $filename\n";
			rename($filename, "$filename.old") || die "Cannot rename $filename\n";
			open(INPUT, "$filename.old") || die "Cannot open $filename.old for reading\n";
			open(OUTPUT, ">$filename") || die "Cannot open $filename for writing\n";

			while($line = <INPUT>) {
				$line =~ s/\r\n/\n/g;
				$line =~ s/\r/\n/g;
			
				print OUTPUT $line;
			}

			close(OUTPUT) || die "Cannot close $filename\n";
			close(INPUT) || die "Cannot close filename.old\n";

			unlink "$filename.old" || die "Could not remove $filename.old\n";
		}
	}
	else {
		print "$filename does not exist\n";
	}
}

