#include <stdlib.h>
#include <stdio.h>

#include "stringclass.h"
#include "DataFilter.hpp"

int main(int argc, char** argv) {
	String output;
	char *filename = "decodeTest";

	FILE *fp;
	char buffer[1024];
	int cnt;

	fp = fopen(filename, "rb");
	if(fp == NULL) {
		printf("Could not open file %s\n", filename);
		exit(1);
	}

	while( (cnt=fread(buffer, 1, 1024, fp)) > 0) {
		output.append(buffer, cnt);
	}

	if(fclose(fp) != 0) {
		printf("Could not close file %s\n", filename);
		exit(1);
	}

	long length = DataFilter::removeWhiteSpace( (unsigned char*) output.getrawstring(), output.getlength() );
    output.reduceLengthTo(length);

	String input = output;

	printf("Initial:\n");
	fwrite(output.getrawstring(), 1, output.getlength(), stdout);
	printf("\n");

	output = DataFilter::decode85(output);
	output = DataFilter::encode85(output);
	// output = DataFilter::decode85(output);

	length = DataFilter::removeWhiteSpace( (unsigned char*) output.getrawstring(), output.getlength() );
    output.reduceLengthTo(length);

	output += "~>";

if(input == output)
	printf("Data matches\n");
else
	printf("Data does not match\n");

	printf("Final:\n");
	fwrite(output.getrawstring(), 1, output.getlength(), stdout);
	printf("\n");

	return 0;
}

