#include "dll_export.h"

struct DllExport Command {
	char* realname;
	char* alias;
	int args;
	char* argtypes;
};

const struct DllExport Command cmdlist[]=
{
	// For each command, all argument types are numbers unless explicit types are listed for the command.
	// Variable arg list means the quantity or types (or both) of arguments is variable.
  {"b*","closepath_eofill_and_stroke",0, NULL},
  {"b","closepath_fill_and_stroke",0, NULL},
  {"BDC","begin_marked_content_with_propertylist",2, "variablearglist"},
  {"B*","eofill_and_stroke",0, NULL},
  {"B","fill_and_stroke",0, NULL},
  {"BI","begin_image",0, NULL},
  {"BMC","begin_marked_content",1, "name"},
  {"BT","begin_text_object",0, NULL},
  {"BX","begin_hiding_undefined_operators",0, NULL},
  {"c","appendbeziercurve",6, NULL},
  {"cm","concatenate_CTM_matrix",6, NULL},
  {"cs","set_fillcolorspace",1, "name"},
  {"CS","set_strokecolorspace",1, "name"},
  {"D0","set_character_width",2, NULL},
  {"D1","set_cache_device",6, NULL},
  {"Do","execute_xobject",1, "xobject"},
  {"DP","mark_point_with_propertylist",2, "variablearglist"},
  {"d","set_dashpattern",2, "array,num"},
  {"EI","end_image",0, NULL},
  {"EMC","end_marked_content",0, NULL},
  {"ET","end_text_object",0, NULL},
  {"EX","end_hiding_undefined_operators",0, NULL},
  {"F","fillpath",0, NULL},
  {"f","fillpath",0, NULL},
  {"f*","fillpath_oddeven",0, NULL},
  {"g","set_grayfilltint",1, NULL},
  {"G","set_graystroketint",1, NULL},
  {"gs","set_graphicsstate",1, "name"},
  {"h","closecurrentsubpath",0, NULL},
  {"ID","begin_image_data",0, NULL},
  {"i","set_flatness",1, NULL},
  {"J","set_linecap",1, NULL},
  {"j","set_linejoin",1, NULL},
  {"k","set_fillcolorCMYK",4, NULL},
  {"K","set_strokecolorCMYK",4, NULL},
  {"l","lineto",2, NULL},
  {"m","moveto",2, NULL},
  {"MP","mark_point",1, "name"},
  {"M","set_miterlimit",1, NULL},
  {"n","endpath",0, NULL},
  {"\"","newline_and_setspacing_and_show_text_string",3, "num,num,string"},
  {"'","newline_and_show_text_string",1, "string"},
  {"PS","exec_postscript",1, "string"},
  {"Q","restore_graphics_state",0, NULL},
  {"q","save_graphics_state",0, NULL},
  {"re","add_rectangle",4, NULL},
  {"rg","set_fillcolorRGB",3, NULL},
  {"RG","set_strokecolorRGB",3, NULL},
  {"ri","set_colorrenderingintent",1, "name"},
  {"s","close_and_strokepath",0, NULL},
  {"SCN","SCN",1, "variablearglist"},
  {"scn","scn",1, "variablearglist"},
  {"sc","set_fillcolor",1, "variablearglist"},
  {"SC","set_strokecolor",1, "variablearglist"},
  {"sh","shade",1, NULL},
  {"S","strokepath",0, NULL},
  {"Tc","set_character_spacing",1, NULL},
  {"Td","newline",2, NULL},
  {"TD","newline_and_set_leading",2, NULL},
  {"Tf","set_font_and_size",2, "name,num"},
  {"Tj","show_text_string",1, "string"},
  {"TJ","show_text_string_with_displacements",1, "array"},
  {"TL","set_text_leading",1, NULL},
  {"Tm","set_text_matrix",6, NULL},
  {"T*","newline_with_defaultoffset",0, NULL},
  {"Tr","set_text_rendering_mode",1, NULL},
  {"Ts","set_text_size",1, NULL},
  {"Tw","set_word_spacing",1, NULL},
  {"Tz","set_horizontal_scaling",1, NULL},
  {"v","appendbeziercurve_current",4, NULL},
  {"W","clip",0, NULL},
  {"W*","clip_evenodd",0, NULL},
  {"w","set_linewidth",1, NULL},
  {"y","appendbeziercurve_current_secondversion",4, NULL}
};

