#include "dll_export.h"

#ifndef _DataFilter_HXX
#define _DataFilter_HXX

#include "stringclass.h"

class DllExport DataFilter {
public:
	// Stuff is static here because none of it relies an internal DataFilter object state (in fact, there
	// isn't even any state, since there aren't any member variables).
	static String encodeXML(String input); // Quote all "command" characters for XML (ie. <>"& )
	static String encodeHex(String input);
	static String decodeHex(String input);
	static String encode85(String input);
	static String decode85(String input);
	static String encodeFlate(String input);
	static String decodeFlate(String input);
	static String convertEOLs(String input); // Same here; what gets converted to what?

	static String encodePDF(String input); // Escape all parentheses (using backslash escape character).
	static String decodePDF(String input); // De-escape all escaped perentheses.
	static long removeWhiteSpace(unsigned char *data, long length);

	static bool isSupportedEncoding(String encoding);
	static String encode(String data, String encoding);
	static String decode(String data, String encoding);
protected:
};

#endif
