#include "dll_export.h"


#ifndef _FileReader_HXX
#define _FileReader_HXX

#include <stdlib.h>
#include <stdio.h>

#define MAX_LINE_LENGTH 256

class DllExport DataReader {
public:
	int linesRead;

	virtual int getLine(char* dest, int maxChars, bool showEOL = false) { return 0;}
	virtual int getByteOffset() { return 0;}
protected:
	int bytesRead;
};

class DllExport FileReader : public DataReader {
public:
	FileReader(char *newFile = NULL); 
	virtual ~FileReader(); 
	virtual int getLine(char* dest, int maxChars, bool showEOL = false);
	virtual int getByteOffset();
protected:
	char* filename;
	FILE *fp;
	char buffer[MAX_LINE_LENGTH+1];
	int bufferCnt;
	char *nextChar, *bufferEnd;

	virtual void closeFile();
	virtual void getNextBlock();
};

class DllExport StringReader: public DataReader {
public:
	StringReader(const char* const newstring, const long dataLength);
	virtual ~StringReader();
	virtual int getLine(char* dest, int maxChars, bool showEOL = false);
	virtual int getByteOffset();
protected:
	const char* const thestring; // Stores the entire string to be parsed (instead of an input file).
	const int totalsize; // Total size of string.

	const char* buffer;
	int bufferCnt;

	const char* nextChar;
	const char* bufferEnd;

	bool dataLeft;
	int currposition; // Current position in string being parsed (instead of current file position).

	void getNextBlock();
};

#endif
