#include "dll_export.h"


#ifndef _FONT_READER_HPP
#define _FONT_READER_HPP

#include "PdfObjects.hpp"

struct DllExport IndexEntry {
	char name[5];
	unsigned long offset;
	unsigned long length;
};
 
struct DllExport CMapEntry {
	unsigned short platformId;
	unsigned short platformSpecificId;
	unsigned long offset;
};
 
struct DllExport NameEntry {
	unsigned short platformId, platformSpecificId, languageId, nameId, length, offset;
};

class DllExport FontReader {
public:
	static void readFont(PdfFont *font);
private:
	static const int OUTPUT_LEVEL /* =1 */ ;

	static IndexEntry* getIndex(char *name, IndexEntry *list, int numEntries, unsigned long fSize);
	static unsigned short readHead(char *data, double *bbox);
	static char* readName(char *data);
	static unsigned long readHHea(char *data);
	static unsigned char* readCmap(char *data, char *encoding);
	static unsigned char* readMacRomanCmapTable(char *cmapData );
	static unsigned char* readWinAnsiCmapTable(char *cmapData );
	static unsigned long* readHmtx(char *data, unsigned long numEntries, unsigned short unitsPerEM, unsigned char* cmap);
};

#endif
