#include "dll_export.h"


#ifndef ObjParser_HXX
#define ObjParser_HXX

#include "PdfObjects.hpp"
#include "pdfc_base.h"
#include "stringclass.h"

class DllExport  ResourceRefList {
public:
	PdfResourceRef *resourceRef;
	ResourceRefList *next;

	ResourceRefList();
	ResourceRefList(PdfResourceRef *newResourceRef);
};

class DllExport  ObjParser {
public:
	PdfRoot* parse(PObj *root);
private:
	static const int OUTPUT_LEVEL /* =1 */ ;	
	static const int DECODE_IMAGES /* =0 */ ;	

	PdfBookmark* parseBookmark(PObj *bookmark, PObj *root, PdfRoot *pdfRoot);
	void parsePages(PObj *pages, PObj *root, PdfRoot *pdfRoot, double *inheritedMediaBox, ResourceRefList *inheritedResources);
	void parseAnnots(PObj *obj, PObj *root, PdfPage *pdfPage, PdfRoot *pdfRoot);
	void parseContents(PObj *contentsRef, PObj *root, PdfPage *pdfPage);
	void parseFilter(PdfResource *pdfResource, PObj *dict, PObj *root);
	PdfFunction* parseFunction(PObj *functStream, PObj *root);
	PdfExtGraphicsState* parseExtGraphicsState(PObj* dict, PObj* root);
	String getColorSpaceCatagory(PObj *colorSpace, PObj *root);
	PdfColorSpace* parseColorSpace(PObj *colorSpace, PObj *root);
	PdfResource* parseXObject(PObj *xObject, PObj *root);
	PdfFont* parseFont(PObj *font, PObj *root);
	void parseFontDescriptor(PObj *fontDesc, PObj *root, PdfFont *pdfFont);

	PObj* dereference(PObj *root, PObj *obj);
	PObj* validateObj(PObj *root, PObj *obj, ObjectType oType);
	PObj* getValidItem(PObj *root, PObj *dict, char* key, ObjectType oType);
	void printDictionary(PObj *dict, char *prefix, PObj *root);
	PdfResource* getResource(PObj *ref, String resourceType, PObj* root, PdfRoot *pdfRoot);

	double* parseMediaBox(PObj *mediaBoxObj, PObj *root);
	ResourceRefList* parseResources(PObj *resourcesDict, PObj *root, PdfRoot *pdfRoot);
};

#endif
