#include "dll_export.h"


#ifndef _PDFTokenizer_HXX
#define _PDFTokenizer_HXX

#include "FileReader.hpp"
#include "pdfc_base.h"
#include "pdfc_basicobjects.h"
#include "stringclass.h"

class DllExport PDFTokenizer {
public:
	PDFTokenizer(DataReader *file);
	PObj* parse(char *endToken, bool parsingpostscript=false);
	PObj* parseContents(bool parsingpostscript=true);

private:
	int getNextToken(char *token, ObjectType *objType, bool discardEOL,  bool advanceToken, bool parsingpostscript=false);
	PObj* getNextObject(int level, bool parsingpostscript=false);
	void indent(int level);
	int jumpWhiteSpaceAndComments();

	bool DEBUG_OUTPUT;
	bool TOKEN_DEBUG;
	bool partialToken;
	bool inStream;
	bool inInlineImage;
	bool inString;
	bool inHexString;
	DataReader *file;
	char buffer[MAX_LINE_LENGTH+1];
	char nextToken[MAX_LINE_LENGTH+1];
	ObjectType lastType;
	char *nextChar;
	char *bufferEnd;
};

PObj* DllExport parse_page_description_to_XML(String contentData);

#endif
