#include "dll_export.h"

#ifndef _XMLHandler_hxx
#define _XMLHandler_hxx

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <iostream.h>

#ifdef WIN32
#include "libxml/parser.h"
#else
#include "parser.h"
#endif

#include "XMLElement.hpp"
#include "XMLModule.hpp"
#include "pdfc_base.h"

#define MAX_STACK_SIZE 100

class DllExport XMLHandler {
 public:
	XMLHandler(XMLModule *newModule);
	void startElement(const xmlChar *name, const xmlChar **attributes);
	void characters( const xmlChar *ch, int len );
	void endElement( const xmlChar *name);

private:
	XMLModule *module;
	bool DEBUG_OUTPUT;
	int level;
	XMLElement** stack;

	void indent();
};

#endif
