#include "dll_export.h"

#ifndef _XMLModule_highLevel_hxx
#define _XMLModule_highLevel_hxx

#include "XMLModule.hpp"
#include "XMLElement.hpp"
#include "PdfObjects.hpp"
#include "XMLModule_lowLevel.hpp"

class DllExport XMLModule_highLevel : public XMLModule {
 public:
	XMLModule_highLevel();
	virtual ~XMLModule_highLevel();

	virtual PdfRoot* getRoot(); 
	virtual void startElement(XMLElement** stack, int level);
	virtual void endElement(XMLElement** stack, int level);
private:
	bool DEBUG_OUTPUT;
	PdfRoot *root;
	PdfObject *currentObj;
	Hash resourceHash;

	bool inContentSection;
	XMLModule_lowLevel contentModule;

	virtual void splitNumsIntoArray(double *array, int numVals, char *str);
};

#endif
