#include "dll_export.h"

#ifndef _XMLReader_HXX
#define _XMLReader_HXX

#include "XMLHandler.hpp"

void DllExport startElement(void *module, const xmlChar *name, const xmlChar **atts);
void DllExport endElement(void *module, const xmlChar *name);
void DllExport characters(void *module, const xmlChar *ch, int len);
 
void DllExport fatal(void *ctx, const char *msg, ...);
void DllExport error(void *ctx, const char *msg, ...);
void DllExport warning(void *ctx, const char *msg, ...);

//-------------------------------------------

#define XMLREADER_BUFFER_SIZE 1024
 
//-------------------------------------------

class DllExport XMLReader {
public:
	static void parseXmlFilePointer(XMLHandler *handler, FILE *fp);
	static void parseXmlFile(XMLHandler *handler, char *filename);
	static void parseXmlMemory(XMLHandler *handler, char *buffer, long bufferLength);
};

#endif

