#include "PdfObjects.hpp"

void PdfFont::initBase14Font() {
	if(fontName == "Courier-Bold")
		setFontCourierBold();
	else if(fontName == "Courier-BoldOblique")
		setFontCourierBoldOblique();
	else if(fontName == "Courier-Oblique")
		setFontCourierOblique();
	else if(fontName == "Courier")
		setFontCourier();

	else if(fontName == "Helvetica-Bold")
		setFontHelveticaBold();
	else if(fontName == "Helvetica-BoldOblique")
		setFontHelveticaBoldOblique();
	else if(fontName == "Helvetica-Oblique")
		setFontHelveticaOblique();
	else if(fontName == "Helvetica")
		setFontHelvetica();

	else if(fontName == "Symbol")
		setFontSymbol();
	else if(fontName == "Times-Bold")
		setFontTimesBold();
	else if(fontName == "Times-BoldItalic")
		setFontTimesBoldItalic();
	else if(fontName == "Times-Italic")
		setFontTimesItalic();
	else if(fontName == "Times-Roman")
		setFontTimesRoman();
	else if(fontName == "ZapfDingbats")
		setFontZapfDingbats();
	else 
		printerr(EOTHER_GENERICERROR, "Error - cannot auto-initialize a font that is not one of the base 14\n");
}


void PdfFont::setFontCourierBold() {
	subType = "Type1";
	fontName = "Courier-Bold";
	ascent = 629;
	numWidths = 220;
	descent = -157;
	firstChar = 32;
	lastChar = 251;
	fontBBox[0] = -113;
	fontBBox[1] = -250;
	fontBBox[2] = 749;
	fontBBox[3] = 801;

	widths = new long[220];
	widths[0] = 600; // 32 space
	widths[1] = 600; // 33 exclam
	widths[2] = 600; // 34 quotedbl
	widths[3] = 600; // 35 numbersign
	widths[4] = 600; // 36 dollar
	widths[5] = 600; // 37 percent
	widths[6] = 600; // 38 ampersand
	widths[7] = 600; // 39 quoteright
	widths[8] = 600; // 40 parenleft
	widths[9] = 600; // 41 parenright
	widths[10] = 600; // 42 asterisk
	widths[11] = 600; // 43 plus
	widths[12] = 600; // 44 comma
	widths[13] = 600; // 45 hyphen
	widths[14] = 600; // 46 period
	widths[15] = 600; // 47 slash
	widths[16] = 600; // 48 zero
	widths[17] = 600; // 49 one
	widths[18] = 600; // 50 two
	widths[19] = 600; // 51 three
	widths[20] = 600; // 52 four
	widths[21] = 600; // 53 five
	widths[22] = 600; // 54 six
	widths[23] = 600; // 55 seven
	widths[24] = 600; // 56 eight
	widths[25] = 600; // 57 nine
	widths[26] = 600; // 58 colon
	widths[27] = 600; // 59 semicolon
	widths[28] = 600; // 60 less
	widths[29] = 600; // 61 equal
	widths[30] = 600; // 62 greater
	widths[31] = 600; // 63 question
	widths[32] = 600; // 64 at
	widths[33] = 600; // 65 A
	widths[34] = 600; // 66 B
	widths[35] = 600; // 67 C
	widths[36] = 600; // 68 D
	widths[37] = 600; // 69 E
	widths[38] = 600; // 70 F
	widths[39] = 600; // 71 G
	widths[40] = 600; // 72 H
	widths[41] = 600; // 73 I
	widths[42] = 600; // 74 J
	widths[43] = 600; // 75 K
	widths[44] = 600; // 76 L
	widths[45] = 600; // 77 M
	widths[46] = 600; // 78 N
	widths[47] = 600; // 79 O
	widths[48] = 600; // 80 P
	widths[49] = 600; // 81 Q
	widths[50] = 600; // 82 R
	widths[51] = 600; // 83 S
	widths[52] = 600; // 84 T
	widths[53] = 600; // 85 U
	widths[54] = 600; // 86 V
	widths[55] = 600; // 87 W
	widths[56] = 600; // 88 X
	widths[57] = 600; // 89 Y
	widths[58] = 600; // 90 Z
	widths[59] = 600; // 91 bracketleft
	widths[60] = 600; // 92 backslash
	widths[61] = 600; // 93 bracketright
	widths[62] = 600; // 94 asciicircum
	widths[63] = 600; // 95 underscore
	widths[64] = 600; // 96 quoteleft
	widths[65] = 600; // 97 a
	widths[66] = 600; // 98 b
	widths[67] = 600; // 99 c
	widths[68] = 600; // 100 d
	widths[69] = 600; // 101 e
	widths[70] = 600; // 102 f
	widths[71] = 600; // 103 g
	widths[72] = 600; // 104 h
	widths[73] = 600; // 105 i
	widths[74] = 600; // 106 j
	widths[75] = 600; // 107 k
	widths[76] = 600; // 108 l
	widths[77] = 600; // 109 m
	widths[78] = 600; // 110 n
	widths[79] = 600; // 111 o
	widths[80] = 600; // 112 p
	widths[81] = 600; // 113 q
	widths[82] = 600; // 114 r
	widths[83] = 600; // 115 s
	widths[84] = 600; // 116 t
	widths[85] = 600; // 117 u
	widths[86] = 600; // 118 v
	widths[87] = 600; // 119 w
	widths[88] = 600; // 120 x
	widths[89] = 600; // 121 y
	widths[90] = 600; // 122 z
	widths[91] = 600; // 123 braceleft
	widths[92] = 600; // 124 bar
	widths[93] = 600; // 125 braceright
	widths[94] = 600; // 126 asciitilde
	widths[95] = 0;
	widths[96] = 0;
	widths[97] = 0;
	widths[98] = 0;
	widths[99] = 0;
	widths[100] = 0;
	widths[101] = 0;
	widths[102] = 0;
	widths[103] = 0;
	widths[104] = 0;
	widths[105] = 0;
	widths[106] = 0;
	widths[107] = 0;
	widths[108] = 0;
	widths[109] = 0;
	widths[110] = 0;
	widths[111] = 0;
	widths[112] = 0;
	widths[113] = 0;
	widths[114] = 0;
	widths[115] = 0;
	widths[116] = 0;
	widths[117] = 0;
	widths[118] = 0;
	widths[119] = 0;
	widths[120] = 0;
	widths[121] = 0;
	widths[122] = 0;
	widths[123] = 0;
	widths[124] = 0;
	widths[125] = 0;
	widths[126] = 0;
	widths[127] = 0;
	widths[128] = 0;
	widths[129] = 600; // 161 exclamdown
	widths[130] = 600; // 162 cent
	widths[131] = 600; // 163 sterling
	widths[132] = 600; // 164 fraction
	widths[133] = 600; // 165 yen
	widths[134] = 600; // 166 florin
	widths[135] = 600; // 167 section
	widths[136] = 600; // 168 currency
	widths[137] = 600; // 169 quotesingle
	widths[138] = 600; // 170 quotedblleft
	widths[139] = 600; // 171 guillemotleft
	widths[140] = 600; // 172 guilsinglleft
	widths[141] = 600; // 173 guilsinglright
	widths[142] = 600; // 174 fi
	widths[143] = 600; // 175 fl
	widths[144] = 0;
	widths[145] = 600; // 177 endash
	widths[146] = 600; // 178 dagger
	widths[147] = 600; // 179 daggerdbl
	widths[148] = 600; // 180 periodcentered
	widths[149] = 0;
	widths[150] = 600; // 182 paragraph
	widths[151] = 600; // 183 bullet
	widths[152] = 600; // 184 quotesinglbase
	widths[153] = 600; // 185 quotedblbase
	widths[154] = 600; // 186 quotedblright
	widths[155] = 600; // 187 guillemotright
	widths[156] = 600; // 188 ellipsis
	widths[157] = 600; // 189 perthousand
	widths[158] = 0;
	widths[159] = 600; // 191 questiondown
	widths[160] = 0;
	widths[161] = 600; // 193 grave
	widths[162] = 600; // 194 acute
	widths[163] = 600; // 195 circumflex
	widths[164] = 600; // 196 tilde
	widths[165] = 600; // 197 macron
	widths[166] = 600; // 198 breve
	widths[167] = 600; // 199 dotaccent
	widths[168] = 600; // 200 dieresis
	widths[169] = 0;
	widths[170] = 600; // 202 ring
	widths[171] = 600; // 203 cedilla
	widths[172] = 0;
	widths[173] = 600; // 205 hungarumlaut
	widths[174] = 600; // 206 ogonek
	widths[175] = 600; // 207 caron
	widths[176] = 600; // 208 emdash
	widths[177] = 0;
	widths[178] = 0;
	widths[179] = 0;
	widths[180] = 0;
	widths[181] = 0;
	widths[182] = 0;
	widths[183] = 0;
	widths[184] = 0;
	widths[185] = 0;
	widths[186] = 0;
	widths[187] = 0;
	widths[188] = 0;
	widths[189] = 0;
	widths[190] = 0;
	widths[191] = 0;
	widths[192] = 0;
	widths[193] = 600; // 225 AE
	widths[194] = 0;
	widths[195] = 600; // 227 ordfeminine
	widths[196] = 0;
	widths[197] = 0;
	widths[198] = 0;
	widths[199] = 0;
	widths[200] = 600; // 232 Lslash
	widths[201] = 600; // 233 Oslash
	widths[202] = 600; // 234 OE
	widths[203] = 600; // 235 ordmasculine
	widths[204] = 0;
	widths[205] = 0;
	widths[206] = 0;
	widths[207] = 0;
	widths[208] = 0;
	widths[209] = 600; // 241 ae
	widths[210] = 0;
	widths[211] = 0;
	widths[212] = 0;
	widths[213] = 600; // 245 dotlessi
	widths[214] = 0;
	widths[215] = 0;
	widths[216] = 600; // 248 lslash
	widths[217] = 600; // 249 oslash
	widths[218] = 600; // 250 oe
	widths[219] = 600; // 251 germandbls
};

void PdfFont::setFontCourierBoldOblique() {
	subType = "Type1";
	fontName = "Courier-BoldOblique";
	ascent = 629;
	numWidths = 220;
	descent = -157;
	firstChar = 32;
	lastChar = 251;
	fontBBox[0] = -57;
	fontBBox[1] = -250;
	fontBBox[2] = 869;
	fontBBox[3] = 801;

	widths = new long[220];
	widths[0] = 600; // 32 space
	widths[1] = 600; // 33 exclam
	widths[2] = 600; // 34 quotedbl
	widths[3] = 600; // 35 numbersign
	widths[4] = 600; // 36 dollar
	widths[5] = 600; // 37 percent
	widths[6] = 600; // 38 ampersand
	widths[7] = 600; // 39 quoteright
	widths[8] = 600; // 40 parenleft
	widths[9] = 600; // 41 parenright
	widths[10] = 600; // 42 asterisk
	widths[11] = 600; // 43 plus
	widths[12] = 600; // 44 comma
	widths[13] = 600; // 45 hyphen
	widths[14] = 600; // 46 period
	widths[15] = 600; // 47 slash
	widths[16] = 600; // 48 zero
	widths[17] = 600; // 49 one
	widths[18] = 600; // 50 two
	widths[19] = 600; // 51 three
	widths[20] = 600; // 52 four
	widths[21] = 600; // 53 five
	widths[22] = 600; // 54 six
	widths[23] = 600; // 55 seven
	widths[24] = 600; // 56 eight
	widths[25] = 600; // 57 nine
	widths[26] = 600; // 58 colon
	widths[27] = 600; // 59 semicolon
	widths[28] = 600; // 60 less
	widths[29] = 600; // 61 equal
	widths[30] = 600; // 62 greater
	widths[31] = 600; // 63 question
	widths[32] = 600; // 64 at
	widths[33] = 600; // 65 A
	widths[34] = 600; // 66 B
	widths[35] = 600; // 67 C
	widths[36] = 600; // 68 D
	widths[37] = 600; // 69 E
	widths[38] = 600; // 70 F
	widths[39] = 600; // 71 G
	widths[40] = 600; // 72 H
	widths[41] = 600; // 73 I
	widths[42] = 600; // 74 J
	widths[43] = 600; // 75 K
	widths[44] = 600; // 76 L
	widths[45] = 600; // 77 M
	widths[46] = 600; // 78 N
	widths[47] = 600; // 79 O
	widths[48] = 600; // 80 P
	widths[49] = 600; // 81 Q
	widths[50] = 600; // 82 R
	widths[51] = 600; // 83 S
	widths[52] = 600; // 84 T
	widths[53] = 600; // 85 U
	widths[54] = 600; // 86 V
	widths[55] = 600; // 87 W
	widths[56] = 600; // 88 X
	widths[57] = 600; // 89 Y
	widths[58] = 600; // 90 Z
	widths[59] = 600; // 91 bracketleft
	widths[60] = 600; // 92 backslash
	widths[61] = 600; // 93 bracketright
	widths[62] = 600; // 94 asciicircum
	widths[63] = 600; // 95 underscore
	widths[64] = 600; // 96 quoteleft
	widths[65] = 600; // 97 a
	widths[66] = 600; // 98 b
	widths[67] = 600; // 99 c
	widths[68] = 600; // 100 d
	widths[69] = 600; // 101 e
	widths[70] = 600; // 102 f
	widths[71] = 600; // 103 g
	widths[72] = 600; // 104 h
	widths[73] = 600; // 105 i
	widths[74] = 600; // 106 j
	widths[75] = 600; // 107 k
	widths[76] = 600; // 108 l
	widths[77] = 600; // 109 m
	widths[78] = 600; // 110 n
	widths[79] = 600; // 111 o
	widths[80] = 600; // 112 p
	widths[81] = 600; // 113 q
	widths[82] = 600; // 114 r
	widths[83] = 600; // 115 s
	widths[84] = 600; // 116 t
	widths[85] = 600; // 117 u
	widths[86] = 600; // 118 v
	widths[87] = 600; // 119 w
	widths[88] = 600; // 120 x
	widths[89] = 600; // 121 y
	widths[90] = 600; // 122 z
	widths[91] = 600; // 123 braceleft
	widths[92] = 600; // 124 bar
	widths[93] = 600; // 125 braceright
	widths[94] = 600; // 126 asciitilde
	widths[95] = 0;
	widths[96] = 0;
	widths[97] = 0;
	widths[98] = 0;
	widths[99] = 0;
	widths[100] = 0;
	widths[101] = 0;
	widths[102] = 0;
	widths[103] = 0;
	widths[104] = 0;
	widths[105] = 0;
	widths[106] = 0;
	widths[107] = 0;
	widths[108] = 0;
	widths[109] = 0;
	widths[110] = 0;
	widths[111] = 0;
	widths[112] = 0;
	widths[113] = 0;
	widths[114] = 0;
	widths[115] = 0;
	widths[116] = 0;
	widths[117] = 0;
	widths[118] = 0;
	widths[119] = 0;
	widths[120] = 0;
	widths[121] = 0;
	widths[122] = 0;
	widths[123] = 0;
	widths[124] = 0;
	widths[125] = 0;
	widths[126] = 0;
	widths[127] = 0;
	widths[128] = 0;
	widths[129] = 600; // 161 exclamdown
	widths[130] = 600; // 162 cent
	widths[131] = 600; // 163 sterling
	widths[132] = 600; // 164 fraction
	widths[133] = 600; // 165 yen
	widths[134] = 600; // 166 florin
	widths[135] = 600; // 167 section
	widths[136] = 600; // 168 currency
	widths[137] = 600; // 169 quotesingle
	widths[138] = 600; // 170 quotedblleft
	widths[139] = 600; // 171 guillemotleft
	widths[140] = 600; // 172 guilsinglleft
	widths[141] = 600; // 173 guilsinglright
	widths[142] = 600; // 174 fi
	widths[143] = 600; // 175 fl
	widths[144] = 0;
	widths[145] = 600; // 177 endash
	widths[146] = 600; // 178 dagger
	widths[147] = 600; // 179 daggerdbl
	widths[148] = 600; // 180 periodcentered
	widths[149] = 0;
	widths[150] = 600; // 182 paragraph
	widths[151] = 600; // 183 bullet
	widths[152] = 600; // 184 quotesinglbase
	widths[153] = 600; // 185 quotedblbase
	widths[154] = 600; // 186 quotedblright
	widths[155] = 600; // 187 guillemotright
	widths[156] = 600; // 188 ellipsis
	widths[157] = 600; // 189 perthousand
	widths[158] = 0;
	widths[159] = 600; // 191 questiondown
	widths[160] = 0;
	widths[161] = 600; // 193 grave
	widths[162] = 600; // 194 acute
	widths[163] = 600; // 195 circumflex
	widths[164] = 600; // 196 tilde
	widths[165] = 600; // 197 macron
	widths[166] = 600; // 198 breve
	widths[167] = 600; // 199 dotaccent
	widths[168] = 600; // 200 dieresis
	widths[169] = 0;
	widths[170] = 600; // 202 ring
	widths[171] = 600; // 203 cedilla
	widths[172] = 0;
	widths[173] = 600; // 205 hungarumlaut
	widths[174] = 600; // 206 ogonek
	widths[175] = 600; // 207 caron
	widths[176] = 600; // 208 emdash
	widths[177] = 0;
	widths[178] = 0;
	widths[179] = 0;
	widths[180] = 0;
	widths[181] = 0;
	widths[182] = 0;
	widths[183] = 0;
	widths[184] = 0;
	widths[185] = 0;
	widths[186] = 0;
	widths[187] = 0;
	widths[188] = 0;
	widths[189] = 0;
	widths[190] = 0;
	widths[191] = 0;
	widths[192] = 0;
	widths[193] = 600; // 225 AE
	widths[194] = 0;
	widths[195] = 600; // 227 ordfeminine
	widths[196] = 0;
	widths[197] = 0;
	widths[198] = 0;
	widths[199] = 0;
	widths[200] = 600; // 232 Lslash
	widths[201] = 600; // 233 Oslash
	widths[202] = 600; // 234 OE
	widths[203] = 600; // 235 ordmasculine
	widths[204] = 0;
	widths[205] = 0;
	widths[206] = 0;
	widths[207] = 0;
	widths[208] = 0;
	widths[209] = 600; // 241 ae
	widths[210] = 0;
	widths[211] = 0;
	widths[212] = 0;
	widths[213] = 600; // 245 dotlessi
	widths[214] = 0;
	widths[215] = 0;
	widths[216] = 600; // 248 lslash
	widths[217] = 600; // 249 oslash
	widths[218] = 600; // 250 oe
	widths[219] = 600; // 251 germandbls
};

void PdfFont::setFontCourierOblique() {
	subType = "Type1";
	fontName = "Courier-Oblique";
	ascent = 629;
	numWidths = 220;
	descent = -157;
	firstChar = 32;
	lastChar = 251;
	fontBBox[0] = -27;
	fontBBox[1] = -250;
	fontBBox[2] = 742;
	fontBBox[3] = 805;

	widths = new long[220];
	widths[0] = 600; // 32 space
	widths[1] = 600; // 33 exclam
	widths[2] = 600; // 34 quotedbl
	widths[3] = 600; // 35 numbersign
	widths[4] = 600; // 36 dollar
	widths[5] = 600; // 37 percent
	widths[6] = 600; // 38 ampersand
	widths[7] = 600; // 39 quoteright
	widths[8] = 600; // 40 parenleft
	widths[9] = 600; // 41 parenright
	widths[10] = 600; // 42 asterisk
	widths[11] = 600; // 43 plus
	widths[12] = 600; // 44 comma
	widths[13] = 600; // 45 hyphen
	widths[14] = 600; // 46 period
	widths[15] = 600; // 47 slash
	widths[16] = 600; // 48 zero
	widths[17] = 600; // 49 one
	widths[18] = 600; // 50 two
	widths[19] = 600; // 51 three
	widths[20] = 600; // 52 four
	widths[21] = 600; // 53 five
	widths[22] = 600; // 54 six
	widths[23] = 600; // 55 seven
	widths[24] = 600; // 56 eight
	widths[25] = 600; // 57 nine
	widths[26] = 600; // 58 colon
	widths[27] = 600; // 59 semicolon
	widths[28] = 600; // 60 less
	widths[29] = 600; // 61 equal
	widths[30] = 600; // 62 greater
	widths[31] = 600; // 63 question
	widths[32] = 600; // 64 at
	widths[33] = 600; // 65 A
	widths[34] = 600; // 66 B
	widths[35] = 600; // 67 C
	widths[36] = 600; // 68 D
	widths[37] = 600; // 69 E
	widths[38] = 600; // 70 F
	widths[39] = 600; // 71 G
	widths[40] = 600; // 72 H
	widths[41] = 600; // 73 I
	widths[42] = 600; // 74 J
	widths[43] = 600; // 75 K
	widths[44] = 600; // 76 L
	widths[45] = 600; // 77 M
	widths[46] = 600; // 78 N
	widths[47] = 600; // 79 O
	widths[48] = 600; // 80 P
	widths[49] = 600; // 81 Q
	widths[50] = 600; // 82 R
	widths[51] = 600; // 83 S
	widths[52] = 600; // 84 T
	widths[53] = 600; // 85 U
	widths[54] = 600; // 86 V
	widths[55] = 600; // 87 W
	widths[56] = 600; // 88 X
	widths[57] = 600; // 89 Y
	widths[58] = 600; // 90 Z
	widths[59] = 600; // 91 bracketleft
	widths[60] = 600; // 92 backslash
	widths[61] = 600; // 93 bracketright
	widths[62] = 600; // 94 asciicircum
	widths[63] = 600; // 95 underscore
	widths[64] = 600; // 96 quoteleft
	widths[65] = 600; // 97 a
	widths[66] = 600; // 98 b
	widths[67] = 600; // 99 c
	widths[68] = 600; // 100 d
	widths[69] = 600; // 101 e
	widths[70] = 600; // 102 f
	widths[71] = 600; // 103 g
	widths[72] = 600; // 104 h
	widths[73] = 600; // 105 i
	widths[74] = 600; // 106 j
	widths[75] = 600; // 107 k
	widths[76] = 600; // 108 l
	widths[77] = 600; // 109 m
	widths[78] = 600; // 110 n
	widths[79] = 600; // 111 o
	widths[80] = 600; // 112 p
	widths[81] = 600; // 113 q
	widths[82] = 600; // 114 r
	widths[83] = 600; // 115 s
	widths[84] = 600; // 116 t
	widths[85] = 600; // 117 u
	widths[86] = 600; // 118 v
	widths[87] = 600; // 119 w
	widths[88] = 600; // 120 x
	widths[89] = 600; // 121 y
	widths[90] = 600; // 122 z
	widths[91] = 600; // 123 braceleft
	widths[92] = 600; // 124 bar
	widths[93] = 600; // 125 braceright
	widths[94] = 600; // 126 asciitilde
	widths[95] = 0;
	widths[96] = 0;
	widths[97] = 0;
	widths[98] = 0;
	widths[99] = 0;
	widths[100] = 0;
	widths[101] = 0;
	widths[102] = 0;
	widths[103] = 0;
	widths[104] = 0;
	widths[105] = 0;
	widths[106] = 0;
	widths[107] = 0;
	widths[108] = 0;
	widths[109] = 0;
	widths[110] = 0;
	widths[111] = 0;
	widths[112] = 0;
	widths[113] = 0;
	widths[114] = 0;
	widths[115] = 0;
	widths[116] = 0;
	widths[117] = 0;
	widths[118] = 0;
	widths[119] = 0;
	widths[120] = 0;
	widths[121] = 0;
	widths[122] = 0;
	widths[123] = 0;
	widths[124] = 0;
	widths[125] = 0;
	widths[126] = 0;
	widths[127] = 0;
	widths[128] = 0;
	widths[129] = 600; // 161 exclamdown
	widths[130] = 600; // 162 cent
	widths[131] = 600; // 163 sterling
	widths[132] = 600; // 164 fraction
	widths[133] = 600; // 165 yen
	widths[134] = 600; // 166 florin
	widths[135] = 600; // 167 section
	widths[136] = 600; // 168 currency
	widths[137] = 600; // 169 quotesingle
	widths[138] = 600; // 170 quotedblleft
	widths[139] = 600; // 171 guillemotleft
	widths[140] = 600; // 172 guilsinglleft
	widths[141] = 600; // 173 guilsinglright
	widths[142] = 600; // 174 fi
	widths[143] = 600; // 175 fl
	widths[144] = 0;
	widths[145] = 600; // 177 endash
	widths[146] = 600; // 178 dagger
	widths[147] = 600; // 179 daggerdbl
	widths[148] = 600; // 180 periodcentered
	widths[149] = 0;
	widths[150] = 600; // 182 paragraph
	widths[151] = 600; // 183 bullet
	widths[152] = 600; // 184 quotesinglbase
	widths[153] = 600; // 185 quotedblbase
	widths[154] = 600; // 186 quotedblright
	widths[155] = 600; // 187 guillemotright
	widths[156] = 600; // 188 ellipsis
	widths[157] = 600; // 189 perthousand
	widths[158] = 0;
	widths[159] = 600; // 191 questiondown
	widths[160] = 0;
	widths[161] = 600; // 193 grave
	widths[162] = 600; // 194 acute
	widths[163] = 600; // 195 circumflex
	widths[164] = 600; // 196 tilde
	widths[165] = 600; // 197 macron
	widths[166] = 600; // 198 breve
	widths[167] = 600; // 199 dotaccent
	widths[168] = 600; // 200 dieresis
	widths[169] = 0;
	widths[170] = 600; // 202 ring
	widths[171] = 600; // 203 cedilla
	widths[172] = 0;
	widths[173] = 600; // 205 hungarumlaut
	widths[174] = 600; // 206 ogonek
	widths[175] = 600; // 207 caron
	widths[176] = 600; // 208 emdash
	widths[177] = 0;
	widths[178] = 0;
	widths[179] = 0;
	widths[180] = 0;
	widths[181] = 0;
	widths[182] = 0;
	widths[183] = 0;
	widths[184] = 0;
	widths[185] = 0;
	widths[186] = 0;
	widths[187] = 0;
	widths[188] = 0;
	widths[189] = 0;
	widths[190] = 0;
	widths[191] = 0;
	widths[192] = 0;
	widths[193] = 600; // 225 AE
	widths[194] = 0;
	widths[195] = 600; // 227 ordfeminine
	widths[196] = 0;
	widths[197] = 0;
	widths[198] = 0;
	widths[199] = 0;
	widths[200] = 600; // 232 Lslash
	widths[201] = 600; // 233 Oslash
	widths[202] = 600; // 234 OE
	widths[203] = 600; // 235 ordmasculine
	widths[204] = 0;
	widths[205] = 0;
	widths[206] = 0;
	widths[207] = 0;
	widths[208] = 0;
	widths[209] = 600; // 241 ae
	widths[210] = 0;
	widths[211] = 0;
	widths[212] = 0;
	widths[213] = 600; // 245 dotlessi
	widths[214] = 0;
	widths[215] = 0;
	widths[216] = 600; // 248 lslash
	widths[217] = 600; // 249 oslash
	widths[218] = 600; // 250 oe
	widths[219] = 600; // 251 germandbls
};

void PdfFont::setFontCourier() {
	subType = "Type1";
	fontName = "Courier";
	ascent = 629;
	numWidths = 220;
	descent = -157;
	firstChar = 32;
	lastChar = 251;
	fontBBox[0] = -23;
	fontBBox[1] = -250;
	fontBBox[2] = 623;
	fontBBox[3] = 805;

	widths = new long[220];
	widths[0] = 600; // 32 space
	widths[1] = 600; // 33 exclam
	widths[2] = 600; // 34 quotedbl
	widths[3] = 600; // 35 numbersign
	widths[4] = 600; // 36 dollar
	widths[5] = 600; // 37 percent
	widths[6] = 600; // 38 ampersand
	widths[7] = 600; // 39 quoteright
	widths[8] = 600; // 40 parenleft
	widths[9] = 600; // 41 parenright
	widths[10] = 600; // 42 asterisk
	widths[11] = 600; // 43 plus
	widths[12] = 600; // 44 comma
	widths[13] = 600; // 45 hyphen
	widths[14] = 600; // 46 period
	widths[15] = 600; // 47 slash
	widths[16] = 600; // 48 zero
	widths[17] = 600; // 49 one
	widths[18] = 600; // 50 two
	widths[19] = 600; // 51 three
	widths[20] = 600; // 52 four
	widths[21] = 600; // 53 five
	widths[22] = 600; // 54 six
	widths[23] = 600; // 55 seven
	widths[24] = 600; // 56 eight
	widths[25] = 600; // 57 nine
	widths[26] = 600; // 58 colon
	widths[27] = 600; // 59 semicolon
	widths[28] = 600; // 60 less
	widths[29] = 600; // 61 equal
	widths[30] = 600; // 62 greater
	widths[31] = 600; // 63 question
	widths[32] = 600; // 64 at
	widths[33] = 600; // 65 A
	widths[34] = 600; // 66 B
	widths[35] = 600; // 67 C
	widths[36] = 600; // 68 D
	widths[37] = 600; // 69 E
	widths[38] = 600; // 70 F
	widths[39] = 600; // 71 G
	widths[40] = 600; // 72 H
	widths[41] = 600; // 73 I
	widths[42] = 600; // 74 J
	widths[43] = 600; // 75 K
	widths[44] = 600; // 76 L
	widths[45] = 600; // 77 M
	widths[46] = 600; // 78 N
	widths[47] = 600; // 79 O
	widths[48] = 600; // 80 P
	widths[49] = 600; // 81 Q
	widths[50] = 600; // 82 R
	widths[51] = 600; // 83 S
	widths[52] = 600; // 84 T
	widths[53] = 600; // 85 U
	widths[54] = 600; // 86 V
	widths[55] = 600; // 87 W
	widths[56] = 600; // 88 X
	widths[57] = 600; // 89 Y
	widths[58] = 600; // 90 Z
	widths[59] = 600; // 91 bracketleft
	widths[60] = 600; // 92 backslash
	widths[61] = 600; // 93 bracketright
	widths[62] = 600; // 94 asciicircum
	widths[63] = 600; // 95 underscore
	widths[64] = 600; // 96 quoteleft
	widths[65] = 600; // 97 a
	widths[66] = 600; // 98 b
	widths[67] = 600; // 99 c
	widths[68] = 600; // 100 d
	widths[69] = 600; // 101 e
	widths[70] = 600; // 102 f
	widths[71] = 600; // 103 g
	widths[72] = 600; // 104 h
	widths[73] = 600; // 105 i
	widths[74] = 600; // 106 j
	widths[75] = 600; // 107 k
	widths[76] = 600; // 108 l
	widths[77] = 600; // 109 m
	widths[78] = 600; // 110 n
	widths[79] = 600; // 111 o
	widths[80] = 600; // 112 p
	widths[81] = 600; // 113 q
	widths[82] = 600; // 114 r
	widths[83] = 600; // 115 s
	widths[84] = 600; // 116 t
	widths[85] = 600; // 117 u
	widths[86] = 600; // 118 v
	widths[87] = 600; // 119 w
	widths[88] = 600; // 120 x
	widths[89] = 600; // 121 y
	widths[90] = 600; // 122 z
	widths[91] = 600; // 123 braceleft
	widths[92] = 600; // 124 bar
	widths[93] = 600; // 125 braceright
	widths[94] = 600; // 126 asciitilde
	widths[95] = 0;
	widths[96] = 0;
	widths[97] = 0;
	widths[98] = 0;
	widths[99] = 0;
	widths[100] = 0;
	widths[101] = 0;
	widths[102] = 0;
	widths[103] = 0;
	widths[104] = 0;
	widths[105] = 0;
	widths[106] = 0;
	widths[107] = 0;
	widths[108] = 0;
	widths[109] = 0;
	widths[110] = 0;
	widths[111] = 0;
	widths[112] = 0;
	widths[113] = 0;
	widths[114] = 0;
	widths[115] = 0;
	widths[116] = 0;
	widths[117] = 0;
	widths[118] = 0;
	widths[119] = 0;
	widths[120] = 0;
	widths[121] = 0;
	widths[122] = 0;
	widths[123] = 0;
	widths[124] = 0;
	widths[125] = 0;
	widths[126] = 0;
	widths[127] = 0;
	widths[128] = 0;
	widths[129] = 600; // 161 exclamdown
	widths[130] = 600; // 162 cent
	widths[131] = 600; // 163 sterling
	widths[132] = 600; // 164 fraction
	widths[133] = 600; // 165 yen
	widths[134] = 600; // 166 florin
	widths[135] = 600; // 167 section
	widths[136] = 600; // 168 currency
	widths[137] = 600; // 169 quotesingle
	widths[138] = 600; // 170 quotedblleft
	widths[139] = 600; // 171 guillemotleft
	widths[140] = 600; // 172 guilsinglleft
	widths[141] = 600; // 173 guilsinglright
	widths[142] = 600; // 174 fi
	widths[143] = 600; // 175 fl
	widths[144] = 0;
	widths[145] = 600; // 177 endash
	widths[146] = 600; // 178 dagger
	widths[147] = 600; // 179 daggerdbl
	widths[148] = 600; // 180 periodcentered
	widths[149] = 0;
	widths[150] = 600; // 182 paragraph
	widths[151] = 600; // 183 bullet
	widths[152] = 600; // 184 quotesinglbase
	widths[153] = 600; // 185 quotedblbase
	widths[154] = 600; // 186 quotedblright
	widths[155] = 600; // 187 guillemotright
	widths[156] = 600; // 188 ellipsis
	widths[157] = 600; // 189 perthousand
	widths[158] = 0;
	widths[159] = 600; // 191 questiondown
	widths[160] = 0;
	widths[161] = 600; // 193 grave
	widths[162] = 600; // 194 acute
	widths[163] = 600; // 195 circumflex
	widths[164] = 600; // 196 tilde
	widths[165] = 600; // 197 macron
	widths[166] = 600; // 198 breve
	widths[167] = 600; // 199 dotaccent
	widths[168] = 600; // 200 dieresis
	widths[169] = 0;
	widths[170] = 600; // 202 ring
	widths[171] = 600; // 203 cedilla
	widths[172] = 0;
	widths[173] = 600; // 205 hungarumlaut
	widths[174] = 600; // 206 ogonek
	widths[175] = 600; // 207 caron
	widths[176] = 600; // 208 emdash
	widths[177] = 0;
	widths[178] = 0;
	widths[179] = 0;
	widths[180] = 0;
	widths[181] = 0;
	widths[182] = 0;
	widths[183] = 0;
	widths[184] = 0;
	widths[185] = 0;
	widths[186] = 0;
	widths[187] = 0;
	widths[188] = 0;
	widths[189] = 0;
	widths[190] = 0;
	widths[191] = 0;
	widths[192] = 0;
	widths[193] = 600; // 225 AE
	widths[194] = 0;
	widths[195] = 600; // 227 ordfeminine
	widths[196] = 0;
	widths[197] = 0;
	widths[198] = 0;
	widths[199] = 0;
	widths[200] = 600; // 232 Lslash
	widths[201] = 600; // 233 Oslash
	widths[202] = 600; // 234 OE
	widths[203] = 600; // 235 ordmasculine
	widths[204] = 0;
	widths[205] = 0;
	widths[206] = 0;
	widths[207] = 0;
	widths[208] = 0;
	widths[209] = 600; // 241 ae
	widths[210] = 0;
	widths[211] = 0;
	widths[212] = 0;
	widths[213] = 600; // 245 dotlessi
	widths[214] = 0;
	widths[215] = 0;
	widths[216] = 600; // 248 lslash
	widths[217] = 600; // 249 oslash
	widths[218] = 600; // 250 oe
	widths[219] = 600; // 251 germandbls
};

void PdfFont::setFontHelveticaBold() {
	subType = "Type1";
	fontName = "Helvetica-Bold";
	ascent = 718;
	numWidths = 220;
	descent = -207;
	firstChar = 32;
	lastChar = 251;
	fontBBox[0] = -170;
	fontBBox[1] = -228;
	fontBBox[2] = 1003;
	fontBBox[3] = 962;

	widths = new long[220];
	widths[0] = 278; // 32 space
	widths[1] = 333; // 33 exclam
	widths[2] = 474; // 34 quotedbl
	widths[3] = 556; // 35 numbersign
	widths[4] = 556; // 36 dollar
	widths[5] = 889; // 37 percent
	widths[6] = 722; // 38 ampersand
	widths[7] = 278; // 39 quoteright
	widths[8] = 333; // 40 parenleft
	widths[9] = 333; // 41 parenright
	widths[10] = 389; // 42 asterisk
	widths[11] = 584; // 43 plus
	widths[12] = 278; // 44 comma
	widths[13] = 333; // 45 hyphen
	widths[14] = 278; // 46 period
	widths[15] = 278; // 47 slash
	widths[16] = 556; // 48 zero
	widths[17] = 556; // 49 one
	widths[18] = 556; // 50 two
	widths[19] = 556; // 51 three
	widths[20] = 556; // 52 four
	widths[21] = 556; // 53 five
	widths[22] = 556; // 54 six
	widths[23] = 556; // 55 seven
	widths[24] = 556; // 56 eight
	widths[25] = 556; // 57 nine
	widths[26] = 333; // 58 colon
	widths[27] = 333; // 59 semicolon
	widths[28] = 584; // 60 less
	widths[29] = 584; // 61 equal
	widths[30] = 584; // 62 greater
	widths[31] = 611; // 63 question
	widths[32] = 975; // 64 at
	widths[33] = 722; // 65 A
	widths[34] = 722; // 66 B
	widths[35] = 722; // 67 C
	widths[36] = 722; // 68 D
	widths[37] = 667; // 69 E
	widths[38] = 611; // 70 F
	widths[39] = 778; // 71 G
	widths[40] = 722; // 72 H
	widths[41] = 278; // 73 I
	widths[42] = 556; // 74 J
	widths[43] = 722; // 75 K
	widths[44] = 611; // 76 L
	widths[45] = 833; // 77 M
	widths[46] = 722; // 78 N
	widths[47] = 778; // 79 O
	widths[48] = 667; // 80 P
	widths[49] = 778; // 81 Q
	widths[50] = 722; // 82 R
	widths[51] = 667; // 83 S
	widths[52] = 611; // 84 T
	widths[53] = 722; // 85 U
	widths[54] = 667; // 86 V
	widths[55] = 944; // 87 W
	widths[56] = 667; // 88 X
	widths[57] = 667; // 89 Y
	widths[58] = 611; // 90 Z
	widths[59] = 333; // 91 bracketleft
	widths[60] = 278; // 92 backslash
	widths[61] = 333; // 93 bracketright
	widths[62] = 584; // 94 asciicircum
	widths[63] = 556; // 95 underscore
	widths[64] = 278; // 96 quoteleft
	widths[65] = 556; // 97 a
	widths[66] = 611; // 98 b
	widths[67] = 556; // 99 c
	widths[68] = 611; // 100 d
	widths[69] = 556; // 101 e
	widths[70] = 333; // 102 f
	widths[71] = 611; // 103 g
	widths[72] = 611; // 104 h
	widths[73] = 278; // 105 i
	widths[74] = 278; // 106 j
	widths[75] = 556; // 107 k
	widths[76] = 278; // 108 l
	widths[77] = 889; // 109 m
	widths[78] = 611; // 110 n
	widths[79] = 611; // 111 o
	widths[80] = 611; // 112 p
	widths[81] = 611; // 113 q
	widths[82] = 389; // 114 r
	widths[83] = 556; // 115 s
	widths[84] = 333; // 116 t
	widths[85] = 611; // 117 u
	widths[86] = 556; // 118 v
	widths[87] = 778; // 119 w
	widths[88] = 556; // 120 x
	widths[89] = 556; // 121 y
	widths[90] = 500; // 122 z
	widths[91] = 389; // 123 braceleft
	widths[92] = 280; // 124 bar
	widths[93] = 389; // 125 braceright
	widths[94] = 584; // 126 asciitilde
	widths[95] = 0;
	widths[96] = 0;
	widths[97] = 0;
	widths[98] = 0;
	widths[99] = 0;
	widths[100] = 0;
	widths[101] = 0;
	widths[102] = 0;
	widths[103] = 0;
	widths[104] = 0;
	widths[105] = 0;
	widths[106] = 0;
	widths[107] = 0;
	widths[108] = 0;
	widths[109] = 0;
	widths[110] = 0;
	widths[111] = 0;
	widths[112] = 0;
	widths[113] = 0;
	widths[114] = 0;
	widths[115] = 0;
	widths[116] = 0;
	widths[117] = 0;
	widths[118] = 0;
	widths[119] = 0;
	widths[120] = 0;
	widths[121] = 0;
	widths[122] = 0;
	widths[123] = 0;
	widths[124] = 0;
	widths[125] = 0;
	widths[126] = 0;
	widths[127] = 0;
	widths[128] = 0;
	widths[129] = 333; // 161 exclamdown
	widths[130] = 556; // 162 cent
	widths[131] = 556; // 163 sterling
	widths[132] = 167; // 164 fraction
	widths[133] = 556; // 165 yen
	widths[134] = 556; // 166 florin
	widths[135] = 556; // 167 section
	widths[136] = 556; // 168 currency
	widths[137] = 238; // 169 quotesingle
	widths[138] = 500; // 170 quotedblleft
	widths[139] = 556; // 171 guillemotleft
	widths[140] = 333; // 172 guilsinglleft
	widths[141] = 333; // 173 guilsinglright
	widths[142] = 611; // 174 fi
	widths[143] = 611; // 175 fl
	widths[144] = 0;
	widths[145] = 556; // 177 endash
	widths[146] = 556; // 178 dagger
	widths[147] = 556; // 179 daggerdbl
	widths[148] = 278; // 180 periodcentered
	widths[149] = 0;
	widths[150] = 556; // 182 paragraph
	widths[151] = 350; // 183 bullet
	widths[152] = 278; // 184 quotesinglbase
	widths[153] = 500; // 185 quotedblbase
	widths[154] = 500; // 186 quotedblright
	widths[155] = 556; // 187 guillemotright
	widths[156] = 1000; // 188 ellipsis
	widths[157] = 1000; // 189 perthousand
	widths[158] = 0;
	widths[159] = 611; // 191 questiondown
	widths[160] = 0;
	widths[161] = 333; // 193 grave
	widths[162] = 333; // 194 acute
	widths[163] = 333; // 195 circumflex
	widths[164] = 333; // 196 tilde
	widths[165] = 333; // 197 macron
	widths[166] = 333; // 198 breve
	widths[167] = 333; // 199 dotaccent
	widths[168] = 333; // 200 dieresis
	widths[169] = 0;
	widths[170] = 333; // 202 ring
	widths[171] = 333; // 203 cedilla
	widths[172] = 0;
	widths[173] = 333; // 205 hungarumlaut
	widths[174] = 333; // 206 ogonek
	widths[175] = 333; // 207 caron
	widths[176] = 1000; // 208 emdash
	widths[177] = 0;
	widths[178] = 0;
	widths[179] = 0;
	widths[180] = 0;
	widths[181] = 0;
	widths[182] = 0;
	widths[183] = 0;
	widths[184] = 0;
	widths[185] = 0;
	widths[186] = 0;
	widths[187] = 0;
	widths[188] = 0;
	widths[189] = 0;
	widths[190] = 0;
	widths[191] = 0;
	widths[192] = 0;
	widths[193] = 1000; // 225 AE
	widths[194] = 0;
	widths[195] = 370; // 227 ordfeminine
	widths[196] = 0;
	widths[197] = 0;
	widths[198] = 0;
	widths[199] = 0;
	widths[200] = 611; // 232 Lslash
	widths[201] = 778; // 233 Oslash
	widths[202] = 1000; // 234 OE
	widths[203] = 365; // 235 ordmasculine
	widths[204] = 0;
	widths[205] = 0;
	widths[206] = 0;
	widths[207] = 0;
	widths[208] = 0;
	widths[209] = 889; // 241 ae
	widths[210] = 0;
	widths[211] = 0;
	widths[212] = 0;
	widths[213] = 278; // 245 dotlessi
	widths[214] = 0;
	widths[215] = 0;
	widths[216] = 278; // 248 lslash
	widths[217] = 611; // 249 oslash
	widths[218] = 944; // 250 oe
	widths[219] = 611; // 251 germandbls
};

void PdfFont::setFontHelveticaBoldOblique() {
	subType = "Type1";
	fontName = "Helvetica-BoldOblique";
	ascent = 718;
	numWidths = 220;
	descent = -207;
	firstChar = 32;
	lastChar = 251;
	fontBBox[0] = -174;
	fontBBox[1] = -228;
	fontBBox[2] = 1114;
	fontBBox[3] = 962;

	widths = new long[220];
	widths[0] = 278; // 32 space
	widths[1] = 333; // 33 exclam
	widths[2] = 474; // 34 quotedbl
	widths[3] = 556; // 35 numbersign
	widths[4] = 556; // 36 dollar
	widths[5] = 889; // 37 percent
	widths[6] = 722; // 38 ampersand
	widths[7] = 278; // 39 quoteright
	widths[8] = 333; // 40 parenleft
	widths[9] = 333; // 41 parenright
	widths[10] = 389; // 42 asterisk
	widths[11] = 584; // 43 plus
	widths[12] = 278; // 44 comma
	widths[13] = 333; // 45 hyphen
	widths[14] = 278; // 46 period
	widths[15] = 278; // 47 slash
	widths[16] = 556; // 48 zero
	widths[17] = 556; // 49 one
	widths[18] = 556; // 50 two
	widths[19] = 556; // 51 three
	widths[20] = 556; // 52 four
	widths[21] = 556; // 53 five
	widths[22] = 556; // 54 six
	widths[23] = 556; // 55 seven
	widths[24] = 556; // 56 eight
	widths[25] = 556; // 57 nine
	widths[26] = 333; // 58 colon
	widths[27] = 333; // 59 semicolon
	widths[28] = 584; // 60 less
	widths[29] = 584; // 61 equal
	widths[30] = 584; // 62 greater
	widths[31] = 611; // 63 question
	widths[32] = 975; // 64 at
	widths[33] = 722; // 65 A
	widths[34] = 722; // 66 B
	widths[35] = 722; // 67 C
	widths[36] = 722; // 68 D
	widths[37] = 667; // 69 E
	widths[38] = 611; // 70 F
	widths[39] = 778; // 71 G
	widths[40] = 722; // 72 H
	widths[41] = 278; // 73 I
	widths[42] = 556; // 74 J
	widths[43] = 722; // 75 K
	widths[44] = 611; // 76 L
	widths[45] = 833; // 77 M
	widths[46] = 722; // 78 N
	widths[47] = 778; // 79 O
	widths[48] = 667; // 80 P
	widths[49] = 778; // 81 Q
	widths[50] = 722; // 82 R
	widths[51] = 667; // 83 S
	widths[52] = 611; // 84 T
	widths[53] = 722; // 85 U
	widths[54] = 667; // 86 V
	widths[55] = 944; // 87 W
	widths[56] = 667; // 88 X
	widths[57] = 667; // 89 Y
	widths[58] = 611; // 90 Z
	widths[59] = 333; // 91 bracketleft
	widths[60] = 278; // 92 backslash
	widths[61] = 333; // 93 bracketright
	widths[62] = 584; // 94 asciicircum
	widths[63] = 556; // 95 underscore
	widths[64] = 278; // 96 quoteleft
	widths[65] = 556; // 97 a
	widths[66] = 611; // 98 b
	widths[67] = 556; // 99 c
	widths[68] = 611; // 100 d
	widths[69] = 556; // 101 e
	widths[70] = 333; // 102 f
	widths[71] = 611; // 103 g
	widths[72] = 611; // 104 h
	widths[73] = 278; // 105 i
	widths[74] = 278; // 106 j
	widths[75] = 556; // 107 k
	widths[76] = 278; // 108 l
	widths[77] = 889; // 109 m
	widths[78] = 611; // 110 n
	widths[79] = 611; // 111 o
	widths[80] = 611; // 112 p
	widths[81] = 611; // 113 q
	widths[82] = 389; // 114 r
	widths[83] = 556; // 115 s
	widths[84] = 333; // 116 t
	widths[85] = 611; // 117 u
	widths[86] = 556; // 118 v
	widths[87] = 778; // 119 w
	widths[88] = 556; // 120 x
	widths[89] = 556; // 121 y
	widths[90] = 500; // 122 z
	widths[91] = 389; // 123 braceleft
	widths[92] = 280; // 124 bar
	widths[93] = 389; // 125 braceright
	widths[94] = 584; // 126 asciitilde
	widths[95] = 0;
	widths[96] = 0;
	widths[97] = 0;
	widths[98] = 0;
	widths[99] = 0;
	widths[100] = 0;
	widths[101] = 0;
	widths[102] = 0;
	widths[103] = 0;
	widths[104] = 0;
	widths[105] = 0;
	widths[106] = 0;
	widths[107] = 0;
	widths[108] = 0;
	widths[109] = 0;
	widths[110] = 0;
	widths[111] = 0;
	widths[112] = 0;
	widths[113] = 0;
	widths[114] = 0;
	widths[115] = 0;
	widths[116] = 0;
	widths[117] = 0;
	widths[118] = 0;
	widths[119] = 0;
	widths[120] = 0;
	widths[121] = 0;
	widths[122] = 0;
	widths[123] = 0;
	widths[124] = 0;
	widths[125] = 0;
	widths[126] = 0;
	widths[127] = 0;
	widths[128] = 0;
	widths[129] = 333; // 161 exclamdown
	widths[130] = 556; // 162 cent
	widths[131] = 556; // 163 sterling
	widths[132] = 167; // 164 fraction
	widths[133] = 556; // 165 yen
	widths[134] = 556; // 166 florin
	widths[135] = 556; // 167 section
	widths[136] = 556; // 168 currency
	widths[137] = 238; // 169 quotesingle
	widths[138] = 500; // 170 quotedblleft
	widths[139] = 556; // 171 guillemotleft
	widths[140] = 333; // 172 guilsinglleft
	widths[141] = 333; // 173 guilsinglright
	widths[142] = 611; // 174 fi
	widths[143] = 611; // 175 fl
	widths[144] = 0;
	widths[145] = 556; // 177 endash
	widths[146] = 556; // 178 dagger
	widths[147] = 556; // 179 daggerdbl
	widths[148] = 278; // 180 periodcentered
	widths[149] = 0;
	widths[150] = 556; // 182 paragraph
	widths[151] = 350; // 183 bullet
	widths[152] = 278; // 184 quotesinglbase
	widths[153] = 500; // 185 quotedblbase
	widths[154] = 500; // 186 quotedblright
	widths[155] = 556; // 187 guillemotright
	widths[156] = 1000; // 188 ellipsis
	widths[157] = 1000; // 189 perthousand
	widths[158] = 0;
	widths[159] = 611; // 191 questiondown
	widths[160] = 0;
	widths[161] = 333; // 193 grave
	widths[162] = 333; // 194 acute
	widths[163] = 333; // 195 circumflex
	widths[164] = 333; // 196 tilde
	widths[165] = 333; // 197 macron
	widths[166] = 333; // 198 breve
	widths[167] = 333; // 199 dotaccent
	widths[168] = 333; // 200 dieresis
	widths[169] = 0;
	widths[170] = 333; // 202 ring
	widths[171] = 333; // 203 cedilla
	widths[172] = 0;
	widths[173] = 333; // 205 hungarumlaut
	widths[174] = 333; // 206 ogonek
	widths[175] = 333; // 207 caron
	widths[176] = 1000; // 208 emdash
	widths[177] = 0;
	widths[178] = 0;
	widths[179] = 0;
	widths[180] = 0;
	widths[181] = 0;
	widths[182] = 0;
	widths[183] = 0;
	widths[184] = 0;
	widths[185] = 0;
	widths[186] = 0;
	widths[187] = 0;
	widths[188] = 0;
	widths[189] = 0;
	widths[190] = 0;
	widths[191] = 0;
	widths[192] = 0;
	widths[193] = 1000; // 225 AE
	widths[194] = 0;
	widths[195] = 370; // 227 ordfeminine
	widths[196] = 0;
	widths[197] = 0;
	widths[198] = 0;
	widths[199] = 0;
	widths[200] = 611; // 232 Lslash
	widths[201] = 778; // 233 Oslash
	widths[202] = 1000; // 234 OE
	widths[203] = 365; // 235 ordmasculine
	widths[204] = 0;
	widths[205] = 0;
	widths[206] = 0;
	widths[207] = 0;
	widths[208] = 0;
	widths[209] = 889; // 241 ae
	widths[210] = 0;
	widths[211] = 0;
	widths[212] = 0;
	widths[213] = 278; // 245 dotlessi
	widths[214] = 0;
	widths[215] = 0;
	widths[216] = 278; // 248 lslash
	widths[217] = 611; // 249 oslash
	widths[218] = 944; // 250 oe
	widths[219] = 611; // 251 germandbls
};

void PdfFont::setFontHelveticaOblique() {
	subType = "Type1";
	fontName = "Helvetica-Oblique";
	ascent = 718;
	numWidths = 220;
	descent = -207;
	firstChar = 32;
	lastChar = 251;
	fontBBox[0] = -170;
	fontBBox[1] = -225;
	fontBBox[2] = 1116;
	fontBBox[3] = 931;

	widths = new long[220];
	widths[0] = 278; // 32 space
	widths[1] = 278; // 33 exclam
	widths[2] = 355; // 34 quotedbl
	widths[3] = 556; // 35 numbersign
	widths[4] = 556; // 36 dollar
	widths[5] = 889; // 37 percent
	widths[6] = 667; // 38 ampersand
	widths[7] = 222; // 39 quoteright
	widths[8] = 333; // 40 parenleft
	widths[9] = 333; // 41 parenright
	widths[10] = 389; // 42 asterisk
	widths[11] = 584; // 43 plus
	widths[12] = 278; // 44 comma
	widths[13] = 333; // 45 hyphen
	widths[14] = 278; // 46 period
	widths[15] = 278; // 47 slash
	widths[16] = 556; // 48 zero
	widths[17] = 556; // 49 one
	widths[18] = 556; // 50 two
	widths[19] = 556; // 51 three
	widths[20] = 556; // 52 four
	widths[21] = 556; // 53 five
	widths[22] = 556; // 54 six
	widths[23] = 556; // 55 seven
	widths[24] = 556; // 56 eight
	widths[25] = 556; // 57 nine
	widths[26] = 278; // 58 colon
	widths[27] = 278; // 59 semicolon
	widths[28] = 584; // 60 less
	widths[29] = 584; // 61 equal
	widths[30] = 584; // 62 greater
	widths[31] = 556; // 63 question
	widths[32] = 1015; // 64 at
	widths[33] = 667; // 65 A
	widths[34] = 667; // 66 B
	widths[35] = 722; // 67 C
	widths[36] = 722; // 68 D
	widths[37] = 667; // 69 E
	widths[38] = 611; // 70 F
	widths[39] = 778; // 71 G
	widths[40] = 722; // 72 H
	widths[41] = 278; // 73 I
	widths[42] = 500; // 74 J
	widths[43] = 667; // 75 K
	widths[44] = 556; // 76 L
	widths[45] = 833; // 77 M
	widths[46] = 722; // 78 N
	widths[47] = 778; // 79 O
	widths[48] = 667; // 80 P
	widths[49] = 778; // 81 Q
	widths[50] = 722; // 82 R
	widths[51] = 667; // 83 S
	widths[52] = 611; // 84 T
	widths[53] = 722; // 85 U
	widths[54] = 667; // 86 V
	widths[55] = 944; // 87 W
	widths[56] = 667; // 88 X
	widths[57] = 667; // 89 Y
	widths[58] = 611; // 90 Z
	widths[59] = 278; // 91 bracketleft
	widths[60] = 278; // 92 backslash
	widths[61] = 278; // 93 bracketright
	widths[62] = 469; // 94 asciicircum
	widths[63] = 556; // 95 underscore
	widths[64] = 222; // 96 quoteleft
	widths[65] = 556; // 97 a
	widths[66] = 556; // 98 b
	widths[67] = 500; // 99 c
	widths[68] = 556; // 100 d
	widths[69] = 556; // 101 e
	widths[70] = 278; // 102 f
	widths[71] = 556; // 103 g
	widths[72] = 556; // 104 h
	widths[73] = 222; // 105 i
	widths[74] = 222; // 106 j
	widths[75] = 500; // 107 k
	widths[76] = 222; // 108 l
	widths[77] = 833; // 109 m
	widths[78] = 556; // 110 n
	widths[79] = 556; // 111 o
	widths[80] = 556; // 112 p
	widths[81] = 556; // 113 q
	widths[82] = 333; // 114 r
	widths[83] = 500; // 115 s
	widths[84] = 278; // 116 t
	widths[85] = 556; // 117 u
	widths[86] = 500; // 118 v
	widths[87] = 722; // 119 w
	widths[88] = 500; // 120 x
	widths[89] = 500; // 121 y
	widths[90] = 500; // 122 z
	widths[91] = 334; // 123 braceleft
	widths[92] = 260; // 124 bar
	widths[93] = 334; // 125 braceright
	widths[94] = 584; // 126 asciitilde
	widths[95] = 0;
	widths[96] = 0;
	widths[97] = 0;
	widths[98] = 0;
	widths[99] = 0;
	widths[100] = 0;
	widths[101] = 0;
	widths[102] = 0;
	widths[103] = 0;
	widths[104] = 0;
	widths[105] = 0;
	widths[106] = 0;
	widths[107] = 0;
	widths[108] = 0;
	widths[109] = 0;
	widths[110] = 0;
	widths[111] = 0;
	widths[112] = 0;
	widths[113] = 0;
	widths[114] = 0;
	widths[115] = 0;
	widths[116] = 0;
	widths[117] = 0;
	widths[118] = 0;
	widths[119] = 0;
	widths[120] = 0;
	widths[121] = 0;
	widths[122] = 0;
	widths[123] = 0;
	widths[124] = 0;
	widths[125] = 0;
	widths[126] = 0;
	widths[127] = 0;
	widths[128] = 0;
	widths[129] = 333; // 161 exclamdown
	widths[130] = 556; // 162 cent
	widths[131] = 556; // 163 sterling
	widths[132] = 167; // 164 fraction
	widths[133] = 556; // 165 yen
	widths[134] = 556; // 166 florin
	widths[135] = 556; // 167 section
	widths[136] = 556; // 168 currency
	widths[137] = 191; // 169 quotesingle
	widths[138] = 333; // 170 quotedblleft
	widths[139] = 556; // 171 guillemotleft
	widths[140] = 333; // 172 guilsinglleft
	widths[141] = 333; // 173 guilsinglright
	widths[142] = 500; // 174 fi
	widths[143] = 500; // 175 fl
	widths[144] = 0;
	widths[145] = 556; // 177 endash
	widths[146] = 556; // 178 dagger
	widths[147] = 556; // 179 daggerdbl
	widths[148] = 278; // 180 periodcentered
	widths[149] = 0;
	widths[150] = 537; // 182 paragraph
	widths[151] = 350; // 183 bullet
	widths[152] = 222; // 184 quotesinglbase
	widths[153] = 333; // 185 quotedblbase
	widths[154] = 333; // 186 quotedblright
	widths[155] = 556; // 187 guillemotright
	widths[156] = 1000; // 188 ellipsis
	widths[157] = 1000; // 189 perthousand
	widths[158] = 0;
	widths[159] = 611; // 191 questiondown
	widths[160] = 0;
	widths[161] = 333; // 193 grave
	widths[162] = 333; // 194 acute
	widths[163] = 333; // 195 circumflex
	widths[164] = 333; // 196 tilde
	widths[165] = 333; // 197 macron
	widths[166] = 333; // 198 breve
	widths[167] = 333; // 199 dotaccent
	widths[168] = 333; // 200 dieresis
	widths[169] = 0;
	widths[170] = 333; // 202 ring
	widths[171] = 333; // 203 cedilla
	widths[172] = 0;
	widths[173] = 333; // 205 hungarumlaut
	widths[174] = 333; // 206 ogonek
	widths[175] = 333; // 207 caron
	widths[176] = 1000; // 208 emdash
	widths[177] = 0;
	widths[178] = 0;
	widths[179] = 0;
	widths[180] = 0;
	widths[181] = 0;
	widths[182] = 0;
	widths[183] = 0;
	widths[184] = 0;
	widths[185] = 0;
	widths[186] = 0;
	widths[187] = 0;
	widths[188] = 0;
	widths[189] = 0;
	widths[190] = 0;
	widths[191] = 0;
	widths[192] = 0;
	widths[193] = 1000; // 225 AE
	widths[194] = 0;
	widths[195] = 370; // 227 ordfeminine
	widths[196] = 0;
	widths[197] = 0;
	widths[198] = 0;
	widths[199] = 0;
	widths[200] = 556; // 232 Lslash
	widths[201] = 778; // 233 Oslash
	widths[202] = 1000; // 234 OE
	widths[203] = 365; // 235 ordmasculine
	widths[204] = 0;
	widths[205] = 0;
	widths[206] = 0;
	widths[207] = 0;
	widths[208] = 0;
	widths[209] = 889; // 241 ae
	widths[210] = 0;
	widths[211] = 0;
	widths[212] = 0;
	widths[213] = 278; // 245 dotlessi
	widths[214] = 0;
	widths[215] = 0;
	widths[216] = 222; // 248 lslash
	widths[217] = 611; // 249 oslash
	widths[218] = 944; // 250 oe
	widths[219] = 611; // 251 germandbls
};

void PdfFont::setFontHelvetica() {
	subType = "Type1";
	fontName = "Helvetica";
	ascent = 718;
	numWidths = 220;
	descent = -207;
	firstChar = 32;
	lastChar = 251;
	fontBBox[0] = -166;
	fontBBox[1] = -225;
	fontBBox[2] = 1000;
	fontBBox[3] = 931;

	widths = new long[220];
	widths[0] = 278; // 32 space
	widths[1] = 278; // 33 exclam
	widths[2] = 355; // 34 quotedbl
	widths[3] = 556; // 35 numbersign
	widths[4] = 556; // 36 dollar
	widths[5] = 889; // 37 percent
	widths[6] = 667; // 38 ampersand
	widths[7] = 222; // 39 quoteright
	widths[8] = 333; // 40 parenleft
	widths[9] = 333; // 41 parenright
	widths[10] = 389; // 42 asterisk
	widths[11] = 584; // 43 plus
	widths[12] = 278; // 44 comma
	widths[13] = 333; // 45 hyphen
	widths[14] = 278; // 46 period
	widths[15] = 278; // 47 slash
	widths[16] = 556; // 48 zero
	widths[17] = 556; // 49 one
	widths[18] = 556; // 50 two
	widths[19] = 556; // 51 three
	widths[20] = 556; // 52 four
	widths[21] = 556; // 53 five
	widths[22] = 556; // 54 six
	widths[23] = 556; // 55 seven
	widths[24] = 556; // 56 eight
	widths[25] = 556; // 57 nine
	widths[26] = 278; // 58 colon
	widths[27] = 278; // 59 semicolon
	widths[28] = 584; // 60 less
	widths[29] = 584; // 61 equal
	widths[30] = 584; // 62 greater
	widths[31] = 556; // 63 question
	widths[32] = 1015; // 64 at
	widths[33] = 667; // 65 A
	widths[34] = 667; // 66 B
	widths[35] = 722; // 67 C
	widths[36] = 722; // 68 D
	widths[37] = 667; // 69 E
	widths[38] = 611; // 70 F
	widths[39] = 778; // 71 G
	widths[40] = 722; // 72 H
	widths[41] = 278; // 73 I
	widths[42] = 500; // 74 J
	widths[43] = 667; // 75 K
	widths[44] = 556; // 76 L
	widths[45] = 833; // 77 M
	widths[46] = 722; // 78 N
	widths[47] = 778; // 79 O
	widths[48] = 667; // 80 P
	widths[49] = 778; // 81 Q
	widths[50] = 722; // 82 R
	widths[51] = 667; // 83 S
	widths[52] = 611; // 84 T
	widths[53] = 722; // 85 U
	widths[54] = 667; // 86 V
	widths[55] = 944; // 87 W
	widths[56] = 667; // 88 X
	widths[57] = 667; // 89 Y
	widths[58] = 611; // 90 Z
	widths[59] = 278; // 91 bracketleft
	widths[60] = 278; // 92 backslash
	widths[61] = 278; // 93 bracketright
	widths[62] = 469; // 94 asciicircum
	widths[63] = 556; // 95 underscore
	widths[64] = 222; // 96 quoteleft
	widths[65] = 556; // 97 a
	widths[66] = 556; // 98 b
	widths[67] = 500; // 99 c
	widths[68] = 556; // 100 d
	widths[69] = 556; // 101 e
	widths[70] = 278; // 102 f
	widths[71] = 556; // 103 g
	widths[72] = 556; // 104 h
	widths[73] = 222; // 105 i
	widths[74] = 222; // 106 j
	widths[75] = 500; // 107 k
	widths[76] = 222; // 108 l
	widths[77] = 833; // 109 m
	widths[78] = 556; // 110 n
	widths[79] = 556; // 111 o
	widths[80] = 556; // 112 p
	widths[81] = 556; // 113 q
	widths[82] = 333; // 114 r
	widths[83] = 500; // 115 s
	widths[84] = 278; // 116 t
	widths[85] = 556; // 117 u
	widths[86] = 500; // 118 v
	widths[87] = 722; // 119 w
	widths[88] = 500; // 120 x
	widths[89] = 500; // 121 y
	widths[90] = 500; // 122 z
	widths[91] = 334; // 123 braceleft
	widths[92] = 260; // 124 bar
	widths[93] = 334; // 125 braceright
	widths[94] = 584; // 126 asciitilde
	widths[95] = 0;
	widths[96] = 0;
	widths[97] = 0;
	widths[98] = 0;
	widths[99] = 0;
	widths[100] = 0;
	widths[101] = 0;
	widths[102] = 0;
	widths[103] = 0;
	widths[104] = 0;
	widths[105] = 0;
	widths[106] = 0;
	widths[107] = 0;
	widths[108] = 0;
	widths[109] = 0;
	widths[110] = 0;
	widths[111] = 0;
	widths[112] = 0;
	widths[113] = 0;
	widths[114] = 0;
	widths[115] = 0;
	widths[116] = 0;
	widths[117] = 0;
	widths[118] = 0;
	widths[119] = 0;
	widths[120] = 0;
	widths[121] = 0;
	widths[122] = 0;
	widths[123] = 0;
	widths[124] = 0;
	widths[125] = 0;
	widths[126] = 0;
	widths[127] = 0;
	widths[128] = 0;
	widths[129] = 333; // 161 exclamdown
	widths[130] = 556; // 162 cent
	widths[131] = 556; // 163 sterling
	widths[132] = 167; // 164 fraction
	widths[133] = 556; // 165 yen
	widths[134] = 556; // 166 florin
	widths[135] = 556; // 167 section
	widths[136] = 556; // 168 currency
	widths[137] = 191; // 169 quotesingle
	widths[138] = 333; // 170 quotedblleft
	widths[139] = 556; // 171 guillemotleft
	widths[140] = 333; // 172 guilsinglleft
	widths[141] = 333; // 173 guilsinglright
	widths[142] = 500; // 174 fi
	widths[143] = 500; // 175 fl
	widths[144] = 0;
	widths[145] = 556; // 177 endash
	widths[146] = 556; // 178 dagger
	widths[147] = 556; // 179 daggerdbl
	widths[148] = 278; // 180 periodcentered
	widths[149] = 0;
	widths[150] = 537; // 182 paragraph
	widths[151] = 350; // 183 bullet
	widths[152] = 222; // 184 quotesinglbase
	widths[153] = 333; // 185 quotedblbase
	widths[154] = 333; // 186 quotedblright
	widths[155] = 556; // 187 guillemotright
	widths[156] = 1000; // 188 ellipsis
	widths[157] = 1000; // 189 perthousand
	widths[158] = 0;
	widths[159] = 611; // 191 questiondown
	widths[160] = 0;
	widths[161] = 333; // 193 grave
	widths[162] = 333; // 194 acute
	widths[163] = 333; // 195 circumflex
	widths[164] = 333; // 196 tilde
	widths[165] = 333; // 197 macron
	widths[166] = 333; // 198 breve
	widths[167] = 333; // 199 dotaccent
	widths[168] = 333; // 200 dieresis
	widths[169] = 0;
	widths[170] = 333; // 202 ring
	widths[171] = 333; // 203 cedilla
	widths[172] = 0;
	widths[173] = 333; // 205 hungarumlaut
	widths[174] = 333; // 206 ogonek
	widths[175] = 333; // 207 caron
	widths[176] = 1000; // 208 emdash
	widths[177] = 0;
	widths[178] = 0;
	widths[179] = 0;
	widths[180] = 0;
	widths[181] = 0;
	widths[182] = 0;
	widths[183] = 0;
	widths[184] = 0;
	widths[185] = 0;
	widths[186] = 0;
	widths[187] = 0;
	widths[188] = 0;
	widths[189] = 0;
	widths[190] = 0;
	widths[191] = 0;
	widths[192] = 0;
	widths[193] = 1000; // 225 AE
	widths[194] = 0;
	widths[195] = 370; // 227 ordfeminine
	widths[196] = 0;
	widths[197] = 0;
	widths[198] = 0;
	widths[199] = 0;
	widths[200] = 556; // 232 Lslash
	widths[201] = 778; // 233 Oslash
	widths[202] = 1000; // 234 OE
	widths[203] = 365; // 235 ordmasculine
	widths[204] = 0;
	widths[205] = 0;
	widths[206] = 0;
	widths[207] = 0;
	widths[208] = 0;
	widths[209] = 889; // 241 ae
	widths[210] = 0;
	widths[211] = 0;
	widths[212] = 0;
	widths[213] = 278; // 245 dotlessi
	widths[214] = 0;
	widths[215] = 0;
	widths[216] = 222; // 248 lslash
	widths[217] = 611; // 249 oslash
	widths[218] = 944; // 250 oe
	widths[219] = 611; // 251 germandbls
};

void PdfFont::setFontSymbol() {
	subType = "Type1";
	fontName = "Symbol";
	ascent = 718;
	numWidths = 223;
	descent = -207;
	firstChar = 32;
	lastChar = 254;
	fontBBox[0] = -180;
	fontBBox[1] = -293;
	fontBBox[2] = 1090;
	fontBBox[3] = 1010;

	widths = new long[223];
	widths[0] = 250; // 32 space
	widths[1] = 333; // 33 exclam
	widths[2] = 713; // 34 universal
	widths[3] = 500; // 35 numbersign
	widths[4] = 549; // 36 existential
	widths[5] = 833; // 37 percent
	widths[6] = 778; // 38 ampersand
	widths[7] = 439; // 39 suchthat
	widths[8] = 333; // 40 parenleft
	widths[9] = 333; // 41 parenright
	widths[10] = 500; // 42 asteriskmath
	widths[11] = 549; // 43 plus
	widths[12] = 250; // 44 comma
	widths[13] = 549; // 45 minus
	widths[14] = 250; // 46 period
	widths[15] = 278; // 47 slash
	widths[16] = 500; // 48 zero
	widths[17] = 500; // 49 one
	widths[18] = 500; // 50 two
	widths[19] = 500; // 51 three
	widths[20] = 500; // 52 four
	widths[21] = 500; // 53 five
	widths[22] = 500; // 54 six
	widths[23] = 500; // 55 seven
	widths[24] = 500; // 56 eight
	widths[25] = 500; // 57 nine
	widths[26] = 278; // 58 colon
	widths[27] = 278; // 59 semicolon
	widths[28] = 549; // 60 less
	widths[29] = 549; // 61 equal
	widths[30] = 549; // 62 greater
	widths[31] = 444; // 63 question
	widths[32] = 549; // 64 congruent
	widths[33] = 722; // 65 Alpha
	widths[34] = 667; // 66 Beta
	widths[35] = 722; // 67 Chi
	widths[36] = 612; // 68 Delta
	widths[37] = 611; // 69 Epsilon
	widths[38] = 763; // 70 Phi
	widths[39] = 603; // 71 Gamma
	widths[40] = 722; // 72 Eta
	widths[41] = 333; // 73 Iota
	widths[42] = 631; // 74 theta1
	widths[43] = 722; // 75 Kappa
	widths[44] = 686; // 76 Lambda
	widths[45] = 889; // 77 Mu
	widths[46] = 722; // 78 Nu
	widths[47] = 722; // 79 Omicron
	widths[48] = 768; // 80 Pi
	widths[49] = 741; // 81 Theta
	widths[50] = 556; // 82 Rho
	widths[51] = 592; // 83 Sigma
	widths[52] = 611; // 84 Tau
	widths[53] = 690; // 85 Upsilon
	widths[54] = 439; // 86 sigma1
	widths[55] = 768; // 87 Omega
	widths[56] = 645; // 88 Xi
	widths[57] = 795; // 89 Psi
	widths[58] = 611; // 90 Zeta
	widths[59] = 333; // 91 bracketleft
	widths[60] = 863; // 92 therefore
	widths[61] = 333; // 93 bracketright
	widths[62] = 658; // 94 perpendicular
	widths[63] = 500; // 95 underscore
	widths[64] = 500; // 96 radicalex
	widths[65] = 631; // 97 alpha
	widths[66] = 549; // 98 beta
	widths[67] = 549; // 99 chi
	widths[68] = 494; // 100 delta
	widths[69] = 439; // 101 epsilon
	widths[70] = 521; // 102 phi
	widths[71] = 411; // 103 gamma
	widths[72] = 603; // 104 eta
	widths[73] = 329; // 105 iota
	widths[74] = 603; // 106 phi1
	widths[75] = 549; // 107 kappa
	widths[76] = 549; // 108 lambda
	widths[77] = 576; // 109 mu
	widths[78] = 521; // 110 nu
	widths[79] = 549; // 111 omicron
	widths[80] = 549; // 112 pi
	widths[81] = 521; // 113 theta
	widths[82] = 549; // 114 rho
	widths[83] = 603; // 115 sigma
	widths[84] = 439; // 116 tau
	widths[85] = 576; // 117 upsilon
	widths[86] = 713; // 118 omega1
	widths[87] = 686; // 119 omega
	widths[88] = 493; // 120 xi
	widths[89] = 686; // 121 psi
	widths[90] = 494; // 122 zeta
	widths[91] = 480; // 123 braceleft
	widths[92] = 200; // 124 bar
	widths[93] = 480; // 125 braceright
	widths[94] = 549; // 126 similar
	widths[95] = 0;
	widths[96] = 0;
	widths[97] = 0;
	widths[98] = 0;
	widths[99] = 0;
	widths[100] = 0;
	widths[101] = 0;
	widths[102] = 0;
	widths[103] = 0;
	widths[104] = 0;
	widths[105] = 0;
	widths[106] = 0;
	widths[107] = 0;
	widths[108] = 0;
	widths[109] = 0;
	widths[110] = 0;
	widths[111] = 0;
	widths[112] = 0;
	widths[113] = 0;
	widths[114] = 0;
	widths[115] = 0;
	widths[116] = 0;
	widths[117] = 0;
	widths[118] = 0;
	widths[119] = 0;
	widths[120] = 0;
	widths[121] = 0;
	widths[122] = 0;
	widths[123] = 0;
	widths[124] = 0;
	widths[125] = 0;
	widths[126] = 0;
	widths[127] = 0;
	widths[128] = 750; // 160 Euro
	widths[129] = 620; // 161 Upsilon1
	widths[130] = 247; // 162 minute
	widths[131] = 549; // 163 lessequal
	widths[132] = 167; // 164 fraction
	widths[133] = 713; // 165 infinity
	widths[134] = 500; // 166 florin
	widths[135] = 753; // 167 club
	widths[136] = 753; // 168 diamond
	widths[137] = 753; // 169 heart
	widths[138] = 753; // 170 spade
	widths[139] = 1042; // 171 arrowboth
	widths[140] = 987; // 172 arrowleft
	widths[141] = 603; // 173 arrowup
	widths[142] = 987; // 174 arrowright
	widths[143] = 603; // 175 arrowdown
	widths[144] = 400; // 176 degree
	widths[145] = 549; // 177 plusminus
	widths[146] = 411; // 178 second
	widths[147] = 549; // 179 greaterequal
	widths[148] = 549; // 180 multiply
	widths[149] = 713; // 181 proportional
	widths[150] = 494; // 182 partialdiff
	widths[151] = 460; // 183 bullet
	widths[152] = 549; // 184 divide
	widths[153] = 549; // 185 notequal
	widths[154] = 549; // 186 equivalence
	widths[155] = 549; // 187 approxequal
	widths[156] = 1000; // 188 ellipsis
	widths[157] = 603; // 189 arrowvertex
	widths[158] = 1000; // 190 arrowhorizex
	widths[159] = 658; // 191 carriagereturn
	widths[160] = 823; // 192 aleph
	widths[161] = 686; // 193 Ifraktur
	widths[162] = 795; // 194 Rfraktur
	widths[163] = 987; // 195 weierstrass
	widths[164] = 768; // 196 circlemultiply
	widths[165] = 768; // 197 circleplus
	widths[166] = 823; // 198 emptyset
	widths[167] = 768; // 199 intersection
	widths[168] = 768; // 200 union
	widths[169] = 713; // 201 propersuperset
	widths[170] = 713; // 202 reflexsuperset
	widths[171] = 713; // 203 notsubset
	widths[172] = 713; // 204 propersubset
	widths[173] = 713; // 205 reflexsubset
	widths[174] = 713; // 206 element
	widths[175] = 713; // 207 notelement
	widths[176] = 768; // 208 angle
	widths[177] = 713; // 209 gradient
	widths[178] = 790; // 210 registerserif
	widths[179] = 790; // 211 copyrightserif
	widths[180] = 890; // 212 trademarkserif
	widths[181] = 823; // 213 product
	widths[182] = 549; // 214 radical
	widths[183] = 250; // 215 dotmath
	widths[184] = 713; // 216 logicalnot
	widths[185] = 603; // 217 logicaland
	widths[186] = 603; // 218 logicalor
	widths[187] = 1042; // 219 arrowdblboth
	widths[188] = 987; // 220 arrowdblleft
	widths[189] = 603; // 221 arrowdblup
	widths[190] = 987; // 222 arrowdblright
	widths[191] = 603; // 223 arrowdbldown
	widths[192] = 494; // 224 lozenge
	widths[193] = 329; // 225 angleleft
	widths[194] = 790; // 226 registersans
	widths[195] = 790; // 227 copyrightsans
	widths[196] = 786; // 228 trademarksans
	widths[197] = 713; // 229 summation
	widths[198] = 384; // 230 parenlefttp
	widths[199] = 384; // 231 parenleftex
	widths[200] = 384; // 232 parenleftbt
	widths[201] = 384; // 233 bracketlefttp
	widths[202] = 384; // 234 bracketleftex
	widths[203] = 384; // 235 bracketleftbt
	widths[204] = 494; // 236 bracelefttp
	widths[205] = 494; // 237 braceleftmid
	widths[206] = 494; // 238 braceleftbt
	widths[207] = 494; // 239 braceex
	widths[208] = 0;
	widths[209] = 329; // 241 angleright
	widths[210] = 274; // 242 integral
	widths[211] = 686; // 243 integraltp
	widths[212] = 686; // 244 integralex
	widths[213] = 686; // 245 integralbt
	widths[214] = 384; // 246 parenrighttp
	widths[215] = 384; // 247 parenrightex
	widths[216] = 384; // 248 parenrightbt
	widths[217] = 384; // 249 bracketrighttp
	widths[218] = 384; // 250 bracketrightex
	widths[219] = 384; // 251 bracketrightbt
	widths[220] = 494; // 252 bracerighttp
	widths[221] = 494; // 253 bracerightmid
	widths[222] = 494; // 254 bracerightbt
};

void PdfFont::setFontTimesBold() {
	subType = "Type1";
	fontName = "Times-Bold";
	ascent = 683;
	numWidths = 220;
	descent = -217;
	firstChar = 32;
	lastChar = 251;
	fontBBox[0] = -168;
	fontBBox[1] = -218;
	fontBBox[2] = 1000;
	fontBBox[3] = 935;

	widths = new long[220];
	widths[0] = 250; // 32 space
	widths[1] = 333; // 33 exclam
	widths[2] = 555; // 34 quotedbl
	widths[3] = 500; // 35 numbersign
	widths[4] = 500; // 36 dollar
	widths[5] = 1000; // 37 percent
	widths[6] = 833; // 38 ampersand
	widths[7] = 333; // 39 quoteright
	widths[8] = 333; // 40 parenleft
	widths[9] = 333; // 41 parenright
	widths[10] = 500; // 42 asterisk
	widths[11] = 570; // 43 plus
	widths[12] = 250; // 44 comma
	widths[13] = 333; // 45 hyphen
	widths[14] = 250; // 46 period
	widths[15] = 278; // 47 slash
	widths[16] = 500; // 48 zero
	widths[17] = 500; // 49 one
	widths[18] = 500; // 50 two
	widths[19] = 500; // 51 three
	widths[20] = 500; // 52 four
	widths[21] = 500; // 53 five
	widths[22] = 500; // 54 six
	widths[23] = 500; // 55 seven
	widths[24] = 500; // 56 eight
	widths[25] = 500; // 57 nine
	widths[26] = 333; // 58 colon
	widths[27] = 333; // 59 semicolon
	widths[28] = 570; // 60 less
	widths[29] = 570; // 61 equal
	widths[30] = 570; // 62 greater
	widths[31] = 500; // 63 question
	widths[32] = 930; // 64 at
	widths[33] = 722; // 65 A
	widths[34] = 667; // 66 B
	widths[35] = 722; // 67 C
	widths[36] = 722; // 68 D
	widths[37] = 667; // 69 E
	widths[38] = 611; // 70 F
	widths[39] = 778; // 71 G
	widths[40] = 778; // 72 H
	widths[41] = 389; // 73 I
	widths[42] = 500; // 74 J
	widths[43] = 778; // 75 K
	widths[44] = 667; // 76 L
	widths[45] = 944; // 77 M
	widths[46] = 722; // 78 N
	widths[47] = 778; // 79 O
	widths[48] = 611; // 80 P
	widths[49] = 778; // 81 Q
	widths[50] = 722; // 82 R
	widths[51] = 556; // 83 S
	widths[52] = 667; // 84 T
	widths[53] = 722; // 85 U
	widths[54] = 722; // 86 V
	widths[55] = 1000; // 87 W
	widths[56] = 722; // 88 X
	widths[57] = 722; // 89 Y
	widths[58] = 667; // 90 Z
	widths[59] = 333; // 91 bracketleft
	widths[60] = 278; // 92 backslash
	widths[61] = 333; // 93 bracketright
	widths[62] = 581; // 94 asciicircum
	widths[63] = 500; // 95 underscore
	widths[64] = 333; // 96 quoteleft
	widths[65] = 500; // 97 a
	widths[66] = 556; // 98 b
	widths[67] = 444; // 99 c
	widths[68] = 556; // 100 d
	widths[69] = 444; // 101 e
	widths[70] = 333; // 102 f
	widths[71] = 500; // 103 g
	widths[72] = 556; // 104 h
	widths[73] = 278; // 105 i
	widths[74] = 333; // 106 j
	widths[75] = 556; // 107 k
	widths[76] = 278; // 108 l
	widths[77] = 833; // 109 m
	widths[78] = 556; // 110 n
	widths[79] = 500; // 111 o
	widths[80] = 556; // 112 p
	widths[81] = 556; // 113 q
	widths[82] = 444; // 114 r
	widths[83] = 389; // 115 s
	widths[84] = 333; // 116 t
	widths[85] = 556; // 117 u
	widths[86] = 500; // 118 v
	widths[87] = 722; // 119 w
	widths[88] = 500; // 120 x
	widths[89] = 500; // 121 y
	widths[90] = 444; // 122 z
	widths[91] = 394; // 123 braceleft
	widths[92] = 220; // 124 bar
	widths[93] = 394; // 125 braceright
	widths[94] = 520; // 126 asciitilde
	widths[95] = 0;
	widths[96] = 0;
	widths[97] = 0;
	widths[98] = 0;
	widths[99] = 0;
	widths[100] = 0;
	widths[101] = 0;
	widths[102] = 0;
	widths[103] = 0;
	widths[104] = 0;
	widths[105] = 0;
	widths[106] = 0;
	widths[107] = 0;
	widths[108] = 0;
	widths[109] = 0;
	widths[110] = 0;
	widths[111] = 0;
	widths[112] = 0;
	widths[113] = 0;
	widths[114] = 0;
	widths[115] = 0;
	widths[116] = 0;
	widths[117] = 0;
	widths[118] = 0;
	widths[119] = 0;
	widths[120] = 0;
	widths[121] = 0;
	widths[122] = 0;
	widths[123] = 0;
	widths[124] = 0;
	widths[125] = 0;
	widths[126] = 0;
	widths[127] = 0;
	widths[128] = 750; // 160 Euro
	widths[129] = 333; // 161 exclamdown
	widths[130] = 500; // 162 cent
	widths[131] = 500; // 163 sterling
	widths[132] = 167; // 164 fraction
	widths[133] = 500; // 165 yen
	widths[134] = 500; // 166 florin
	widths[135] = 500; // 167 section
	widths[136] = 500; // 168 currency
	widths[137] = 278; // 169 quotesingle
	widths[138] = 500; // 170 quotedblleft
	widths[139] = 500; // 171 guillemotleft
	widths[140] = 333; // 172 guilsinglleft
	widths[141] = 333; // 173 guilsinglright
	widths[142] = 556; // 174 fi
	widths[143] = 556; // 175 fl
	widths[144] = 400; // 176 degree
	widths[145] = 500; // 177 endash
	widths[146] = 500; // 178 dagger
	widths[147] = 500; // 179 daggerdbl
	widths[148] = 250; // 180 periodcentered
	widths[149] = 713; // 181 proportional
	widths[150] = 540; // 182 paragraph
	widths[151] = 350; // 183 bullet
	widths[152] = 333; // 184 quotesinglbase
	widths[153] = 500; // 185 quotedblbase
	widths[154] = 500; // 186 quotedblright
	widths[155] = 500; // 187 guillemotright
	widths[156] = 1000; // 188 ellipsis
	widths[157] = 1000; // 189 perthousand
	widths[158] = 1000; // 190 arrowhorizex
	widths[159] = 500; // 191 questiondown
	widths[160] = 823; // 192 aleph
	widths[161] = 333; // 193 grave
	widths[162] = 333; // 194 acute
	widths[163] = 333; // 195 circumflex
	widths[164] = 333; // 196 tilde
	widths[165] = 333; // 197 macron
	widths[166] = 333; // 198 breve
	widths[167] = 333; // 199 dotaccent
	widths[168] = 333; // 200 dieresis
	widths[169] = 713; // 201 propersuperset
	widths[170] = 333; // 202 ring
	widths[171] = 333; // 203 cedilla
	widths[172] = 713; // 204 propersubset
	widths[173] = 333; // 205 hungarumlaut
	widths[174] = 333; // 206 ogonek
	widths[175] = 333; // 207 caron
	widths[176] = 1000; // 208 emdash
	widths[177] = 713; // 209 gradient
	widths[178] = 790; // 210 registerserif
	widths[179] = 790; // 211 copyrightserif
	widths[180] = 890; // 212 trademarkserif
	widths[181] = 823; // 213 product
	widths[182] = 549; // 214 radical
	widths[183] = 250; // 215 dotmath
	widths[184] = 713; // 216 logicalnot
	widths[185] = 603; // 217 logicaland
	widths[186] = 603; // 218 logicalor
	widths[187] = 1042; // 219 arrowdblboth
	widths[188] = 987; // 220 arrowdblleft
	widths[189] = 603; // 221 arrowdblup
	widths[190] = 987; // 222 arrowdblright
	widths[191] = 603; // 223 arrowdbldown
	widths[192] = 494; // 224 lozenge
	widths[193] = 1000; // 225 AE
	widths[194] = 790; // 226 registersans
	widths[195] = 300; // 227 ordfeminine
	widths[196] = 786; // 228 trademarksans
	widths[197] = 713; // 229 summation
	widths[198] = 384; // 230 parenlefttp
	widths[199] = 384; // 231 parenleftex
	widths[200] = 667; // 232 Lslash
	widths[201] = 778; // 233 Oslash
	widths[202] = 1000; // 234 OE
	widths[203] = 330; // 235 ordmasculine
	widths[204] = 494; // 236 bracelefttp
	widths[205] = 494; // 237 braceleftmid
	widths[206] = 494; // 238 braceleftbt
	widths[207] = 494; // 239 braceex
	widths[208] = 0;
	widths[209] = 722; // 241 ae
	widths[210] = 274; // 242 integral
	widths[211] = 686; // 243 integraltp
	widths[212] = 686; // 244 integralex
	widths[213] = 278; // 245 dotlessi
	widths[214] = 384; // 246 parenrighttp
	widths[215] = 384; // 247 parenrightex
	widths[216] = 278; // 248 lslash
	widths[217] = 500; // 249 oslash
	widths[218] = 722; // 250 oe
	widths[219] = 556; // 251 germandbls
};

void PdfFont::setFontTimesBoldItalic() {
	subType = "Type1";
	fontName = "Times-BoldItalic";
	ascent = 683;
	numWidths = 220;
	descent = -217;
	firstChar = 32;
	lastChar = 251;
	fontBBox[0] = -200;
	fontBBox[1] = -218;
	fontBBox[2] = 996;
	fontBBox[3] = 921;

	widths = new long[220];
	widths[0] = 250; // 32 space
	widths[1] = 389; // 33 exclam
	widths[2] = 555; // 34 quotedbl
	widths[3] = 500; // 35 numbersign
	widths[4] = 500; // 36 dollar
	widths[5] = 833; // 37 percent
	widths[6] = 778; // 38 ampersand
	widths[7] = 333; // 39 quoteright
	widths[8] = 333; // 40 parenleft
	widths[9] = 333; // 41 parenright
	widths[10] = 500; // 42 asterisk
	widths[11] = 570; // 43 plus
	widths[12] = 250; // 44 comma
	widths[13] = 333; // 45 hyphen
	widths[14] = 250; // 46 period
	widths[15] = 278; // 47 slash
	widths[16] = 500; // 48 zero
	widths[17] = 500; // 49 one
	widths[18] = 500; // 50 two
	widths[19] = 500; // 51 three
	widths[20] = 500; // 52 four
	widths[21] = 500; // 53 five
	widths[22] = 500; // 54 six
	widths[23] = 500; // 55 seven
	widths[24] = 500; // 56 eight
	widths[25] = 500; // 57 nine
	widths[26] = 333; // 58 colon
	widths[27] = 333; // 59 semicolon
	widths[28] = 570; // 60 less
	widths[29] = 570; // 61 equal
	widths[30] = 570; // 62 greater
	widths[31] = 500; // 63 question
	widths[32] = 832; // 64 at
	widths[33] = 667; // 65 A
	widths[34] = 667; // 66 B
	widths[35] = 667; // 67 C
	widths[36] = 722; // 68 D
	widths[37] = 667; // 69 E
	widths[38] = 667; // 70 F
	widths[39] = 722; // 71 G
	widths[40] = 778; // 72 H
	widths[41] = 389; // 73 I
	widths[42] = 500; // 74 J
	widths[43] = 667; // 75 K
	widths[44] = 611; // 76 L
	widths[45] = 889; // 77 M
	widths[46] = 722; // 78 N
	widths[47] = 722; // 79 O
	widths[48] = 611; // 80 P
	widths[49] = 722; // 81 Q
	widths[50] = 667; // 82 R
	widths[51] = 556; // 83 S
	widths[52] = 611; // 84 T
	widths[53] = 722; // 85 U
	widths[54] = 667; // 86 V
	widths[55] = 889; // 87 W
	widths[56] = 667; // 88 X
	widths[57] = 611; // 89 Y
	widths[58] = 611; // 90 Z
	widths[59] = 333; // 91 bracketleft
	widths[60] = 278; // 92 backslash
	widths[61] = 333; // 93 bracketright
	widths[62] = 570; // 94 asciicircum
	widths[63] = 500; // 95 underscore
	widths[64] = 333; // 96 quoteleft
	widths[65] = 500; // 97 a
	widths[66] = 500; // 98 b
	widths[67] = 444; // 99 c
	widths[68] = 500; // 100 d
	widths[69] = 444; // 101 e
	widths[70] = 333; // 102 f
	widths[71] = 500; // 103 g
	widths[72] = 556; // 104 h
	widths[73] = 278; // 105 i
	widths[74] = 278; // 106 j
	widths[75] = 500; // 107 k
	widths[76] = 278; // 108 l
	widths[77] = 778; // 109 m
	widths[78] = 556; // 110 n
	widths[79] = 500; // 111 o
	widths[80] = 500; // 112 p
	widths[81] = 500; // 113 q
	widths[82] = 389; // 114 r
	widths[83] = 389; // 115 s
	widths[84] = 278; // 116 t
	widths[85] = 556; // 117 u
	widths[86] = 444; // 118 v
	widths[87] = 667; // 119 w
	widths[88] = 500; // 120 x
	widths[89] = 444; // 121 y
	widths[90] = 389; // 122 z
	widths[91] = 348; // 123 braceleft
	widths[92] = 220; // 124 bar
	widths[93] = 348; // 125 braceright
	widths[94] = 570; // 126 asciitilde
	widths[95] = 0;
	widths[96] = 0;
	widths[97] = 0;
	widths[98] = 0;
	widths[99] = 0;
	widths[100] = 0;
	widths[101] = 0;
	widths[102] = 0;
	widths[103] = 0;
	widths[104] = 0;
	widths[105] = 0;
	widths[106] = 0;
	widths[107] = 0;
	widths[108] = 0;
	widths[109] = 0;
	widths[110] = 0;
	widths[111] = 0;
	widths[112] = 0;
	widths[113] = 0;
	widths[114] = 0;
	widths[115] = 0;
	widths[116] = 0;
	widths[117] = 0;
	widths[118] = 0;
	widths[119] = 0;
	widths[120] = 0;
	widths[121] = 0;
	widths[122] = 0;
	widths[123] = 0;
	widths[124] = 0;
	widths[125] = 0;
	widths[126] = 0;
	widths[127] = 0;
	widths[128] = 750; // 160 Euro
	widths[129] = 389; // 161 exclamdown
	widths[130] = 500; // 162 cent
	widths[131] = 500; // 163 sterling
	widths[132] = 167; // 164 fraction
	widths[133] = 500; // 165 yen
	widths[134] = 500; // 166 florin
	widths[135] = 500; // 167 section
	widths[136] = 500; // 168 currency
	widths[137] = 278; // 169 quotesingle
	widths[138] = 500; // 170 quotedblleft
	widths[139] = 500; // 171 guillemotleft
	widths[140] = 333; // 172 guilsinglleft
	widths[141] = 333; // 173 guilsinglright
	widths[142] = 556; // 174 fi
	widths[143] = 556; // 175 fl
	widths[144] = 400; // 176 degree
	widths[145] = 500; // 177 endash
	widths[146] = 500; // 178 dagger
	widths[147] = 500; // 179 daggerdbl
	widths[148] = 250; // 180 periodcentered
	widths[149] = 713; // 181 proportional
	widths[150] = 500; // 182 paragraph
	widths[151] = 350; // 183 bullet
	widths[152] = 333; // 184 quotesinglbase
	widths[153] = 500; // 185 quotedblbase
	widths[154] = 500; // 186 quotedblright
	widths[155] = 500; // 187 guillemotright
	widths[156] = 1000; // 188 ellipsis
	widths[157] = 1000; // 189 perthousand
	widths[158] = 1000; // 190 arrowhorizex
	widths[159] = 500; // 191 questiondown
	widths[160] = 823; // 192 aleph
	widths[161] = 333; // 193 grave
	widths[162] = 333; // 194 acute
	widths[163] = 333; // 195 circumflex
	widths[164] = 333; // 196 tilde
	widths[165] = 333; // 197 macron
	widths[166] = 333; // 198 breve
	widths[167] = 333; // 199 dotaccent
	widths[168] = 333; // 200 dieresis
	widths[169] = 713; // 201 propersuperset
	widths[170] = 333; // 202 ring
	widths[171] = 333; // 203 cedilla
	widths[172] = 713; // 204 propersubset
	widths[173] = 333; // 205 hungarumlaut
	widths[174] = 333; // 206 ogonek
	widths[175] = 333; // 207 caron
	widths[176] = 1000; // 208 emdash
	widths[177] = 713; // 209 gradient
	widths[178] = 790; // 210 registerserif
	widths[179] = 790; // 211 copyrightserif
	widths[180] = 890; // 212 trademarkserif
	widths[181] = 823; // 213 product
	widths[182] = 549; // 214 radical
	widths[183] = 250; // 215 dotmath
	widths[184] = 713; // 216 logicalnot
	widths[185] = 603; // 217 logicaland
	widths[186] = 603; // 218 logicalor
	widths[187] = 1042; // 219 arrowdblboth
	widths[188] = 987; // 220 arrowdblleft
	widths[189] = 603; // 221 arrowdblup
	widths[190] = 987; // 222 arrowdblright
	widths[191] = 603; // 223 arrowdbldown
	widths[192] = 494; // 224 lozenge
	widths[193] = 944; // 225 AE
	widths[194] = 790; // 226 registersans
	widths[195] = 266; // 227 ordfeminine
	widths[196] = 786; // 228 trademarksans
	widths[197] = 713; // 229 summation
	widths[198] = 384; // 230 parenlefttp
	widths[199] = 384; // 231 parenleftex
	widths[200] = 611; // 232 Lslash
	widths[201] = 722; // 233 Oslash
	widths[202] = 944; // 234 OE
	widths[203] = 300; // 235 ordmasculine
	widths[204] = 494; // 236 bracelefttp
	widths[205] = 494; // 237 braceleftmid
	widths[206] = 494; // 238 braceleftbt
	widths[207] = 494; // 239 braceex
	widths[208] = 0;
	widths[209] = 722; // 241 ae
	widths[210] = 274; // 242 integral
	widths[211] = 686; // 243 integraltp
	widths[212] = 686; // 244 integralex
	widths[213] = 278; // 245 dotlessi
	widths[214] = 384; // 246 parenrighttp
	widths[215] = 384; // 247 parenrightex
	widths[216] = 278; // 248 lslash
	widths[217] = 500; // 249 oslash
	widths[218] = 722; // 250 oe
	widths[219] = 500; // 251 germandbls
};

void PdfFont::setFontTimesItalic() {
	subType = "Type1";
	fontName = "Times-Italic";
	ascent = 683;
	numWidths = 220;
	descent = -217;
	firstChar = 32;
	lastChar = 251;
	fontBBox[0] = -169;
	fontBBox[1] = -217;
	fontBBox[2] = 1010;
	fontBBox[3] = 883;

	widths = new long[220];
	widths[0] = 250; // 32 space
	widths[1] = 333; // 33 exclam
	widths[2] = 420; // 34 quotedbl
	widths[3] = 500; // 35 numbersign
	widths[4] = 500; // 36 dollar
	widths[5] = 833; // 37 percent
	widths[6] = 778; // 38 ampersand
	widths[7] = 333; // 39 quoteright
	widths[8] = 333; // 40 parenleft
	widths[9] = 333; // 41 parenright
	widths[10] = 500; // 42 asterisk
	widths[11] = 675; // 43 plus
	widths[12] = 250; // 44 comma
	widths[13] = 333; // 45 hyphen
	widths[14] = 250; // 46 period
	widths[15] = 278; // 47 slash
	widths[16] = 500; // 48 zero
	widths[17] = 500; // 49 one
	widths[18] = 500; // 50 two
	widths[19] = 500; // 51 three
	widths[20] = 500; // 52 four
	widths[21] = 500; // 53 five
	widths[22] = 500; // 54 six
	widths[23] = 500; // 55 seven
	widths[24] = 500; // 56 eight
	widths[25] = 500; // 57 nine
	widths[26] = 333; // 58 colon
	widths[27] = 333; // 59 semicolon
	widths[28] = 675; // 60 less
	widths[29] = 675; // 61 equal
	widths[30] = 675; // 62 greater
	widths[31] = 500; // 63 question
	widths[32] = 920; // 64 at
	widths[33] = 611; // 65 A
	widths[34] = 611; // 66 B
	widths[35] = 667; // 67 C
	widths[36] = 722; // 68 D
	widths[37] = 611; // 69 E
	widths[38] = 611; // 70 F
	widths[39] = 722; // 71 G
	widths[40] = 722; // 72 H
	widths[41] = 333; // 73 I
	widths[42] = 444; // 74 J
	widths[43] = 667; // 75 K
	widths[44] = 556; // 76 L
	widths[45] = 833; // 77 M
	widths[46] = 667; // 78 N
	widths[47] = 722; // 79 O
	widths[48] = 611; // 80 P
	widths[49] = 722; // 81 Q
	widths[50] = 611; // 82 R
	widths[51] = 500; // 83 S
	widths[52] = 556; // 84 T
	widths[53] = 722; // 85 U
	widths[54] = 611; // 86 V
	widths[55] = 833; // 87 W
	widths[56] = 611; // 88 X
	widths[57] = 556; // 89 Y
	widths[58] = 556; // 90 Z
	widths[59] = 389; // 91 bracketleft
	widths[60] = 278; // 92 backslash
	widths[61] = 389; // 93 bracketright
	widths[62] = 422; // 94 asciicircum
	widths[63] = 500; // 95 underscore
	widths[64] = 333; // 96 quoteleft
	widths[65] = 500; // 97 a
	widths[66] = 500; // 98 b
	widths[67] = 444; // 99 c
	widths[68] = 500; // 100 d
	widths[69] = 444; // 101 e
	widths[70] = 278; // 102 f
	widths[71] = 500; // 103 g
	widths[72] = 500; // 104 h
	widths[73] = 278; // 105 i
	widths[74] = 278; // 106 j
	widths[75] = 444; // 107 k
	widths[76] = 278; // 108 l
	widths[77] = 722; // 109 m
	widths[78] = 500; // 110 n
	widths[79] = 500; // 111 o
	widths[80] = 500; // 112 p
	widths[81] = 500; // 113 q
	widths[82] = 389; // 114 r
	widths[83] = 389; // 115 s
	widths[84] = 278; // 116 t
	widths[85] = 500; // 117 u
	widths[86] = 444; // 118 v
	widths[87] = 667; // 119 w
	widths[88] = 444; // 120 x
	widths[89] = 444; // 121 y
	widths[90] = 389; // 122 z
	widths[91] = 400; // 123 braceleft
	widths[92] = 275; // 124 bar
	widths[93] = 400; // 125 braceright
	widths[94] = 541; // 126 asciitilde
	widths[95] = 0;
	widths[96] = 0;
	widths[97] = 0;
	widths[98] = 0;
	widths[99] = 0;
	widths[100] = 0;
	widths[101] = 0;
	widths[102] = 0;
	widths[103] = 0;
	widths[104] = 0;
	widths[105] = 0;
	widths[106] = 0;
	widths[107] = 0;
	widths[108] = 0;
	widths[109] = 0;
	widths[110] = 0;
	widths[111] = 0;
	widths[112] = 0;
	widths[113] = 0;
	widths[114] = 0;
	widths[115] = 0;
	widths[116] = 0;
	widths[117] = 0;
	widths[118] = 0;
	widths[119] = 0;
	widths[120] = 0;
	widths[121] = 0;
	widths[122] = 0;
	widths[123] = 0;
	widths[124] = 0;
	widths[125] = 0;
	widths[126] = 0;
	widths[127] = 0;
	widths[128] = 750; // 160 Euro
	widths[129] = 389; // 161 exclamdown
	widths[130] = 500; // 162 cent
	widths[131] = 500; // 163 sterling
	widths[132] = 167; // 164 fraction
	widths[133] = 500; // 165 yen
	widths[134] = 500; // 166 florin
	widths[135] = 500; // 167 section
	widths[136] = 500; // 168 currency
	widths[137] = 214; // 169 quotesingle
	widths[138] = 556; // 170 quotedblleft
	widths[139] = 500; // 171 guillemotleft
	widths[140] = 333; // 172 guilsinglleft
	widths[141] = 333; // 173 guilsinglright
	widths[142] = 500; // 174 fi
	widths[143] = 500; // 175 fl
	widths[144] = 400; // 176 degree
	widths[145] = 500; // 177 endash
	widths[146] = 500; // 178 dagger
	widths[147] = 500; // 179 daggerdbl
	widths[148] = 250; // 180 periodcentered
	widths[149] = 713; // 181 proportional
	widths[150] = 523; // 182 paragraph
	widths[151] = 350; // 183 bullet
	widths[152] = 333; // 184 quotesinglbase
	widths[153] = 556; // 185 quotedblbase
	widths[154] = 556; // 186 quotedblright
	widths[155] = 500; // 187 guillemotright
	widths[156] = 889; // 188 ellipsis
	widths[157] = 1000; // 189 perthousand
	widths[158] = 1000; // 190 arrowhorizex
	widths[159] = 500; // 191 questiondown
	widths[160] = 823; // 192 aleph
	widths[161] = 333; // 193 grave
	widths[162] = 333; // 194 acute
	widths[163] = 333; // 195 circumflex
	widths[164] = 333; // 196 tilde
	widths[165] = 333; // 197 macron
	widths[166] = 333; // 198 breve
	widths[167] = 333; // 199 dotaccent
	widths[168] = 333; // 200 dieresis
	widths[169] = 713; // 201 propersuperset
	widths[170] = 333; // 202 ring
	widths[171] = 333; // 203 cedilla
	widths[172] = 713; // 204 propersubset
	widths[173] = 333; // 205 hungarumlaut
	widths[174] = 333; // 206 ogonek
	widths[175] = 333; // 207 caron
	widths[176] = 889; // 208 emdash
	widths[177] = 713; // 209 gradient
	widths[178] = 790; // 210 registerserif
	widths[179] = 790; // 211 copyrightserif
	widths[180] = 890; // 212 trademarkserif
	widths[181] = 823; // 213 product
	widths[182] = 549; // 214 radical
	widths[183] = 250; // 215 dotmath
	widths[184] = 713; // 216 logicalnot
	widths[185] = 603; // 217 logicaland
	widths[186] = 603; // 218 logicalor
	widths[187] = 1042; // 219 arrowdblboth
	widths[188] = 987; // 220 arrowdblleft
	widths[189] = 603; // 221 arrowdblup
	widths[190] = 987; // 222 arrowdblright
	widths[191] = 603; // 223 arrowdbldown
	widths[192] = 494; // 224 lozenge
	widths[193] = 889; // 225 AE
	widths[194] = 790; // 226 registersans
	widths[195] = 276; // 227 ordfeminine
	widths[196] = 786; // 228 trademarksans
	widths[197] = 713; // 229 summation
	widths[198] = 384; // 230 parenlefttp
	widths[199] = 384; // 231 parenleftex
	widths[200] = 556; // 232 Lslash
	widths[201] = 722; // 233 Oslash
	widths[202] = 944; // 234 OE
	widths[203] = 310; // 235 ordmasculine
	widths[204] = 494; // 236 bracelefttp
	widths[205] = 494; // 237 braceleftmid
	widths[206] = 494; // 238 braceleftbt
	widths[207] = 494; // 239 braceex
	widths[208] = 0;
	widths[209] = 667; // 241 ae
	widths[210] = 274; // 242 integral
	widths[211] = 686; // 243 integraltp
	widths[212] = 686; // 244 integralex
	widths[213] = 278; // 245 dotlessi
	widths[214] = 384; // 246 parenrighttp
	widths[215] = 384; // 247 parenrightex
	widths[216] = 278; // 248 lslash
	widths[217] = 500; // 249 oslash
	widths[218] = 667; // 250 oe
	widths[219] = 500; // 251 germandbls
};

void PdfFont::setFontTimesRoman() {
	subType = "Type1";
	fontName = "Times-Roman";
	ascent = 683;
	numWidths = 220;
	descent = -217;
	firstChar = 32;
	lastChar = 251;
	fontBBox[0] = -168;
	fontBBox[1] = -218;
	fontBBox[2] = 1000;
	fontBBox[3] = 898;

	widths = new long[220];
	widths[0] = 250; // 32 space
	widths[1] = 333; // 33 exclam
	widths[2] = 408; // 34 quotedbl
	widths[3] = 500; // 35 numbersign
	widths[4] = 500; // 36 dollar
	widths[5] = 833; // 37 percent
	widths[6] = 778; // 38 ampersand
	widths[7] = 333; // 39 quoteright
	widths[8] = 333; // 40 parenleft
	widths[9] = 333; // 41 parenright
	widths[10] = 500; // 42 asterisk
	widths[11] = 564; // 43 plus
	widths[12] = 250; // 44 comma
	widths[13] = 333; // 45 hyphen
	widths[14] = 250; // 46 period
	widths[15] = 278; // 47 slash
	widths[16] = 500; // 48 zero
	widths[17] = 500; // 49 one
	widths[18] = 500; // 50 two
	widths[19] = 500; // 51 three
	widths[20] = 500; // 52 four
	widths[21] = 500; // 53 five
	widths[22] = 500; // 54 six
	widths[23] = 500; // 55 seven
	widths[24] = 500; // 56 eight
	widths[25] = 500; // 57 nine
	widths[26] = 278; // 58 colon
	widths[27] = 278; // 59 semicolon
	widths[28] = 564; // 60 less
	widths[29] = 564; // 61 equal
	widths[30] = 564; // 62 greater
	widths[31] = 444; // 63 question
	widths[32] = 921; // 64 at
	widths[33] = 722; // 65 A
	widths[34] = 667; // 66 B
	widths[35] = 667; // 67 C
	widths[36] = 722; // 68 D
	widths[37] = 611; // 69 E
	widths[38] = 556; // 70 F
	widths[39] = 722; // 71 G
	widths[40] = 722; // 72 H
	widths[41] = 333; // 73 I
	widths[42] = 389; // 74 J
	widths[43] = 722; // 75 K
	widths[44] = 611; // 76 L
	widths[45] = 889; // 77 M
	widths[46] = 722; // 78 N
	widths[47] = 722; // 79 O
	widths[48] = 556; // 80 P
	widths[49] = 722; // 81 Q
	widths[50] = 667; // 82 R
	widths[51] = 556; // 83 S
	widths[52] = 611; // 84 T
	widths[53] = 722; // 85 U
	widths[54] = 722; // 86 V
	widths[55] = 944; // 87 W
	widths[56] = 722; // 88 X
	widths[57] = 722; // 89 Y
	widths[58] = 611; // 90 Z
	widths[59] = 333; // 91 bracketleft
	widths[60] = 278; // 92 backslash
	widths[61] = 333; // 93 bracketright
	widths[62] = 469; // 94 asciicircum
	widths[63] = 500; // 95 underscore
	widths[64] = 333; // 96 quoteleft
	widths[65] = 444; // 97 a
	widths[66] = 500; // 98 b
	widths[67] = 444; // 99 c
	widths[68] = 500; // 100 d
	widths[69] = 444; // 101 e
	widths[70] = 333; // 102 f
	widths[71] = 500; // 103 g
	widths[72] = 500; // 104 h
	widths[73] = 278; // 105 i
	widths[74] = 278; // 106 j
	widths[75] = 500; // 107 k
	widths[76] = 278; // 108 l
	widths[77] = 778; // 109 m
	widths[78] = 500; // 110 n
	widths[79] = 500; // 111 o
	widths[80] = 500; // 112 p
	widths[81] = 500; // 113 q
	widths[82] = 333; // 114 r
	widths[83] = 389; // 115 s
	widths[84] = 278; // 116 t
	widths[85] = 500; // 117 u
	widths[86] = 500; // 118 v
	widths[87] = 722; // 119 w
	widths[88] = 500; // 120 x
	widths[89] = 500; // 121 y
	widths[90] = 444; // 122 z
	widths[91] = 480; // 123 braceleft
	widths[92] = 200; // 124 bar
	widths[93] = 480; // 125 braceright
	widths[94] = 541; // 126 asciitilde
	widths[95] = 0;
	widths[96] = 0;
	widths[97] = 0;
	widths[98] = 0;
	widths[99] = 0;
	widths[100] = 0;
	widths[101] = 0;
	widths[102] = 0;
	widths[103] = 0;
	widths[104] = 0;
	widths[105] = 0;
	widths[106] = 0;
	widths[107] = 0;
	widths[108] = 0;
	widths[109] = 0;
	widths[110] = 0;
	widths[111] = 0;
	widths[112] = 0;
	widths[113] = 0;
	widths[114] = 0;
	widths[115] = 0;
	widths[116] = 0;
	widths[117] = 0;
	widths[118] = 0;
	widths[119] = 0;
	widths[120] = 0;
	widths[121] = 0;
	widths[122] = 0;
	widths[123] = 0;
	widths[124] = 0;
	widths[125] = 0;
	widths[126] = 0;
	widths[127] = 0;
	widths[128] = 750; // 160 Euro
	widths[129] = 333; // 161 exclamdown
	widths[130] = 500; // 162 cent
	widths[131] = 500; // 163 sterling
	widths[132] = 167; // 164 fraction
	widths[133] = 500; // 165 yen
	widths[134] = 500; // 166 florin
	widths[135] = 500; // 167 section
	widths[136] = 500; // 168 currency
	widths[137] = 180; // 169 quotesingle
	widths[138] = 444; // 170 quotedblleft
	widths[139] = 500; // 171 guillemotleft
	widths[140] = 333; // 172 guilsinglleft
	widths[141] = 333; // 173 guilsinglright
	widths[142] = 556; // 174 fi
	widths[143] = 556; // 175 fl
	widths[144] = 400; // 176 degree
	widths[145] = 500; // 177 endash
	widths[146] = 500; // 178 dagger
	widths[147] = 500; // 179 daggerdbl
	widths[148] = 250; // 180 periodcentered
	widths[149] = 713; // 181 proportional
	widths[150] = 453; // 182 paragraph
	widths[151] = 350; // 183 bullet
	widths[152] = 333; // 184 quotesinglbase
	widths[153] = 444; // 185 quotedblbase
	widths[154] = 444; // 186 quotedblright
	widths[155] = 500; // 187 guillemotright
	widths[156] = 1000; // 188 ellipsis
	widths[157] = 1000; // 189 perthousand
	widths[158] = 1000; // 190 arrowhorizex
	widths[159] = 444; // 191 questiondown
	widths[160] = 823; // 192 aleph
	widths[161] = 333; // 193 grave
	widths[162] = 333; // 194 acute
	widths[163] = 333; // 195 circumflex
	widths[164] = 333; // 196 tilde
	widths[165] = 333; // 197 macron
	widths[166] = 333; // 198 breve
	widths[167] = 333; // 199 dotaccent
	widths[168] = 333; // 200 dieresis
	widths[169] = 713; // 201 propersuperset
	widths[170] = 333; // 202 ring
	widths[171] = 333; // 203 cedilla
	widths[172] = 713; // 204 propersubset
	widths[173] = 333; // 205 hungarumlaut
	widths[174] = 333; // 206 ogonek
	widths[175] = 333; // 207 caron
	widths[176] = 1000; // 208 emdash
	widths[177] = 713; // 209 gradient
	widths[178] = 790; // 210 registerserif
	widths[179] = 790; // 211 copyrightserif
	widths[180] = 890; // 212 trademarkserif
	widths[181] = 823; // 213 product
	widths[182] = 549; // 214 radical
	widths[183] = 250; // 215 dotmath
	widths[184] = 713; // 216 logicalnot
	widths[185] = 603; // 217 logicaland
	widths[186] = 603; // 218 logicalor
	widths[187] = 1042; // 219 arrowdblboth
	widths[188] = 987; // 220 arrowdblleft
	widths[189] = 603; // 221 arrowdblup
	widths[190] = 987; // 222 arrowdblright
	widths[191] = 603; // 223 arrowdbldown
	widths[192] = 494; // 224 lozenge
	widths[193] = 889; // 225 AE
	widths[194] = 790; // 226 registersans
	widths[195] = 276; // 227 ordfeminine
	widths[196] = 786; // 228 trademarksans
	widths[197] = 713; // 229 summation
	widths[198] = 384; // 230 parenlefttp
	widths[199] = 384; // 231 parenleftex
	widths[200] = 611; // 232 Lslash
	widths[201] = 722; // 233 Oslash
	widths[202] = 889; // 234 OE
	widths[203] = 310; // 235 ordmasculine
	widths[204] = 494; // 236 bracelefttp
	widths[205] = 494; // 237 braceleftmid
	widths[206] = 494; // 238 braceleftbt
	widths[207] = 494; // 239 braceex
	widths[208] = 0;
	widths[209] = 667; // 241 ae
	widths[210] = 274; // 242 integral
	widths[211] = 686; // 243 integraltp
	widths[212] = 686; // 244 integralex
	widths[213] = 278; // 245 dotlessi
	widths[214] = 384; // 246 parenrighttp
	widths[215] = 384; // 247 parenrightex
	widths[216] = 278; // 248 lslash
	widths[217] = 500; // 249 oslash
	widths[218] = 722; // 250 oe
	widths[219] = 500; // 251 germandbls
};

void PdfFont::setFontZapfDingbats() {
	subType = "Type1";
	fontName = "ZapfDingbats";
	ascent = 683;
	numWidths = 223;
	descent = -217;
	firstChar = 32;
	lastChar = 254;
	fontBBox[0] = -1;
	fontBBox[1] = -143;
	fontBBox[2] = 981;
	fontBBox[3] = 820;

	widths = new long[223];
	widths[0] = 278; // 32 space
	widths[1] = 974; // 33 a1
	widths[2] = 961; // 34 a2
	widths[3] = 974; // 35 a202
	widths[4] = 980; // 36 a3
	widths[5] = 719; // 37 a4
	widths[6] = 789; // 38 a5
	widths[7] = 790; // 39 a119
	widths[8] = 791; // 40 a118
	widths[9] = 690; // 41 a117
	widths[10] = 960; // 42 a11
	widths[11] = 939; // 43 a12
	widths[12] = 549; // 44 a13
	widths[13] = 855; // 45 a14
	widths[14] = 911; // 46 a15
	widths[15] = 933; // 47 a16
	widths[16] = 911; // 48 a105
	widths[17] = 945; // 49 a17
	widths[18] = 974; // 50 a18
	widths[19] = 755; // 51 a19
	widths[20] = 846; // 52 a20
	widths[21] = 762; // 53 a21
	widths[22] = 761; // 54 a22
	widths[23] = 571; // 55 a23
	widths[24] = 677; // 56 a24
	widths[25] = 763; // 57 a25
	widths[26] = 760; // 58 a26
	widths[27] = 759; // 59 a27
	widths[28] = 754; // 60 a28
	widths[29] = 494; // 61 a6
	widths[30] = 552; // 62 a7
	widths[31] = 537; // 63 a8
	widths[32] = 577; // 64 a9
	widths[33] = 692; // 65 a10
	widths[34] = 786; // 66 a29
	widths[35] = 788; // 67 a30
	widths[36] = 788; // 68 a31
	widths[37] = 790; // 69 a32
	widths[38] = 793; // 70 a33
	widths[39] = 794; // 71 a34
	widths[40] = 816; // 72 a35
	widths[41] = 823; // 73 a36
	widths[42] = 789; // 74 a37
	widths[43] = 841; // 75 a38
	widths[44] = 823; // 76 a39
	widths[45] = 833; // 77 a40
	widths[46] = 816; // 78 a41
	widths[47] = 831; // 79 a42
	widths[48] = 923; // 80 a43
	widths[49] = 744; // 81 a44
	widths[50] = 723; // 82 a45
	widths[51] = 749; // 83 a46
	widths[52] = 790; // 84 a47
	widths[53] = 792; // 85 a48
	widths[54] = 695; // 86 a49
	widths[55] = 776; // 87 a50
	widths[56] = 768; // 88 a51
	widths[57] = 792; // 89 a52
	widths[58] = 759; // 90 a53
	widths[59] = 707; // 91 a54
	widths[60] = 708; // 92 a55
	widths[61] = 682; // 93 a56
	widths[62] = 701; // 94 a57
	widths[63] = 826; // 95 a58
	widths[64] = 815; // 96 a59
	widths[65] = 789; // 97 a60
	widths[66] = 789; // 98 a61
	widths[67] = 707; // 99 a62
	widths[68] = 687; // 100 a63
	widths[69] = 696; // 101 a64
	widths[70] = 689; // 102 a65
	widths[71] = 786; // 103 a66
	widths[72] = 787; // 104 a67
	widths[73] = 713; // 105 a68
	widths[74] = 791; // 106 a69
	widths[75] = 785; // 107 a70
	widths[76] = 791; // 108 a71
	widths[77] = 873; // 109 a72
	widths[78] = 761; // 110 a73
	widths[79] = 762; // 111 a74
	widths[80] = 762; // 112 a203
	widths[81] = 759; // 113 a75
	widths[82] = 759; // 114 a204
	widths[83] = 892; // 115 a76
	widths[84] = 892; // 116 a77
	widths[85] = 788; // 117 a78
	widths[86] = 784; // 118 a79
	widths[87] = 438; // 119 a81
	widths[88] = 138; // 120 a82
	widths[89] = 277; // 121 a83
	widths[90] = 415; // 122 a84
	widths[91] = 392; // 123 a97
	widths[92] = 392; // 124 a98
	widths[93] = 668; // 125 a99
	widths[94] = 668; // 126 a100
	widths[95] = 0;
	widths[96] = 390; // 128 a89
	widths[97] = 390; // 129 a90
	widths[98] = 317; // 130 a93
	widths[99] = 317; // 131 a94
	widths[100] = 276; // 132 a91
	widths[101] = 276; // 133 a92
	widths[102] = 509; // 134 a205
	widths[103] = 509; // 135 a85
	widths[104] = 410; // 136 a206
	widths[105] = 410; // 137 a86
	widths[106] = 234; // 138 a87
	widths[107] = 234; // 139 a88
	widths[108] = 334; // 140 a95
	widths[109] = 334; // 141 a96
	widths[110] = 0;
	widths[111] = 0;
	widths[112] = 0;
	widths[113] = 0;
	widths[114] = 0;
	widths[115] = 0;
	widths[116] = 0;
	widths[117] = 0;
	widths[118] = 0;
	widths[119] = 0;
	widths[120] = 0;
	widths[121] = 0;
	widths[122] = 0;
	widths[123] = 0;
	widths[124] = 0;
	widths[125] = 0;
	widths[126] = 0;
	widths[127] = 0;
	widths[128] = 750; // 160 Euro
	widths[129] = 732; // 161 a101
	widths[130] = 544; // 162 a102
	widths[131] = 544; // 163 a103
	widths[132] = 910; // 164 a104
	widths[133] = 667; // 165 a106
	widths[134] = 760; // 166 a107
	widths[135] = 760; // 167 a108
	widths[136] = 776; // 168 a112
	widths[137] = 595; // 169 a111
	widths[138] = 694; // 170 a110
	widths[139] = 626; // 171 a109
	widths[140] = 788; // 172 a120
	widths[141] = 788; // 173 a121
	widths[142] = 788; // 174 a122
	widths[143] = 788; // 175 a123
	widths[144] = 788; // 176 a124
	widths[145] = 788; // 177 a125
	widths[146] = 788; // 178 a126
	widths[147] = 788; // 179 a127
	widths[148] = 788; // 180 a128
	widths[149] = 788; // 181 a129
	widths[150] = 788; // 182 a130
	widths[151] = 788; // 183 a131
	widths[152] = 788; // 184 a132
	widths[153] = 788; // 185 a133
	widths[154] = 788; // 186 a134
	widths[155] = 788; // 187 a135
	widths[156] = 788; // 188 a136
	widths[157] = 788; // 189 a137
	widths[158] = 788; // 190 a138
	widths[159] = 788; // 191 a139
	widths[160] = 788; // 192 a140
	widths[161] = 788; // 193 a141
	widths[162] = 788; // 194 a142
	widths[163] = 788; // 195 a143
	widths[164] = 788; // 196 a144
	widths[165] = 788; // 197 a145
	widths[166] = 788; // 198 a146
	widths[167] = 788; // 199 a147
	widths[168] = 788; // 200 a148
	widths[169] = 788; // 201 a149
	widths[170] = 788; // 202 a150
	widths[171] = 788; // 203 a151
	widths[172] = 788; // 204 a152
	widths[173] = 788; // 205 a153
	widths[174] = 788; // 206 a154
	widths[175] = 788; // 207 a155
	widths[176] = 788; // 208 a156
	widths[177] = 788; // 209 a157
	widths[178] = 788; // 210 a158
	widths[179] = 788; // 211 a159
	widths[180] = 894; // 212 a160
	widths[181] = 838; // 213 a161
	widths[182] = 1016; // 214 a163
	widths[183] = 458; // 215 a164
	widths[184] = 748; // 216 a196
	widths[185] = 924; // 217 a165
	widths[186] = 748; // 218 a192
	widths[187] = 918; // 219 a166
	widths[188] = 927; // 220 a167
	widths[189] = 928; // 221 a168
	widths[190] = 928; // 222 a169
	widths[191] = 834; // 223 a170
	widths[192] = 873; // 224 a171
	widths[193] = 828; // 225 a172
	widths[194] = 924; // 226 a173
	widths[195] = 924; // 227 a162
	widths[196] = 917; // 228 a174
	widths[197] = 930; // 229 a175
	widths[198] = 931; // 230 a176
	widths[199] = 463; // 231 a177
	widths[200] = 883; // 232 a178
	widths[201] = 836; // 233 a179
	widths[202] = 836; // 234 a193
	widths[203] = 867; // 235 a180
	widths[204] = 867; // 236 a199
	widths[205] = 696; // 237 a181
	widths[206] = 696; // 238 a200
	widths[207] = 874; // 239 a182
	widths[208] = 0;
	widths[209] = 874; // 241 a201
	widths[210] = 760; // 242 a183
	widths[211] = 946; // 243 a184
	widths[212] = 771; // 244 a197
	widths[213] = 865; // 245 a185
	widths[214] = 771; // 246 a194
	widths[215] = 888; // 247 a198
	widths[216] = 967; // 248 a186
	widths[217] = 888; // 249 a195
	widths[218] = 831; // 250 a187
	widths[219] = 873; // 251 a188
	widths[220] = 927; // 252 a189
	widths[221] = 970; // 253 a190
	widths[222] = 918; // 254 a191
};

