#include "RegExUtil.hpp"

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "PDFTokenizer.hpp"

#ifdef WIN32
#include "regex_win32custom.h"
#else
#include <regex.h>
#endif

int RegExUtil::match(char *str, char *regex) {
    regex_t regex_struct;
    int status;
 
    if(regcomp(&regex_struct, regex, REG_EXTENDED) != 0) {
        printf("Error loading regex\n");
        return 0;
    }
    status = regexec(&regex_struct, str, (size_t) 0, NULL,0);
    regfree(&regex_struct);
 
    if(status == 0) 
		return 1;
    else 
		return 0;
}  

char **RegExUtil::matchList(char *str, char *regex) {
    regex_t regex_struct;
	regmatch_t match_phrase[RegExUtil_MAX_SUB_EXPRESSIONS];
    int status;
	int i, cnt, len;
	char **results = NULL;
 
    if(regcomp(&regex_struct, regex, REG_EXTENDED) != 0) {
        printf("Error loading regex\n");
        return 0;
    }
 
    status = regexec(&regex_struct, str, (size_t) RegExUtil_MAX_SUB_EXPRESSIONS, match_phrase,0);
    regfree(&regex_struct);

    if(status == 0) {
		for(cnt=0; cnt<RegExUtil_MAX_SUB_EXPRESSIONS && match_phrase[cnt].rm_so != -1; cnt++);

		results = new char*[cnt+1];

		for(i=0; i<cnt; i++) {
			len = match_phrase[i].rm_eo-match_phrase[i].rm_so;
			results[i] = new char[len+1];

			strncpy(results[i], str+match_phrase[i].rm_so, len);
			results[i][len] = 0;
		}
		results[i] = NULL;
	}

	return results;
}  

void RegExUtil::freeMatches(char **matches) {
	char **ptr = matches;

	while(*ptr != NULL) {
		delete *ptr;
		ptr++;
	}
	delete [] matches;
}
