#include "XMLElement.hpp"

#include <stdlib.h>
#include <stdio.h>
#include <string.h>

XMLElement::XMLElement() {
	name = NULL;
	attrName = NULL;
	attrValue = NULL;
	attrLen = 0;
	encoding = NULL;
	mapsToElement = false;
}

XMLElement::XMLElement(const xmlChar *newName, const xmlChar **attributes) {
	int i;

	name = new char[strlen((char*)(newName))+1];
	strcpy(name, (char*)(newName));
	
	attrLen = 0;
	if (attributes != NULL) {
		for(attrLen = 0; attributes[2*attrLen] != NULL; attrLen++);
	}

	if(attrLen > 0) {
		attrName = new char*[attrLen];
		attrValue = new char*[attrLen];
	}
	else {
		attrName = NULL;
		attrValue = NULL;
	}

	for(i=0; i<attrLen; i++) {
		attrName[i] = new char[strlen((char*)(attributes)[2*i])+1];
		attrValue[i] = new char[strlen((char*)(attributes)[2*i+1])+1];

		strcpy(attrName[i], (char*)(attributes)[2*i]);
		strcpy(attrValue[i], (char*)(attributes)[2*i+1]);
	} 

	encoding = NULL;
	mapsToElement = false;
}

void XMLElement::appendToCData(const xmlChar *ch, int len) {
	cdata.append((char *)ch, len);
}

char* XMLElement::getAttribute(char *key) {
	int i;

	for(i=0; i<attrLen; i++) {
		if(strcmp(attrName[i], key) == 0) 
			return attrValue[i];
	}
	return NULL;
}

XMLElement::~XMLElement() {
	int i;

	// printf("Delete Name: %s\n", name);
	if(name != NULL) 
		delete [] name;
	if(attrLen != 0) {
		for(i=0; i<attrLen; i++) {
			// printf("Delete Attribure: %s->%s\n", attrName[i], attrValue[i]);
			delete [] attrName[i];
			delete [] attrValue[i];
		}
		delete [] attrName;
		delete [] attrValue;
	}
	attrLen = 0;

	if(encoding != NULL) {
		delete [] encoding;
	}
}

