// WARNING: this stuff got changed from flat array strings to fragmented strings.  Not all of the code has
// been updated yet, and not all of the code that needs updating has been marked as such yet;
// some of it might blow up gloriously.


// Erm, I really need to make a mutable and an immutable class.  Having one string class for both
// purposes is getting really hairy...

#include "stringclass.h"

#define DEBUG_PRINTALLOCATIONS false
#define DEBUG_FUNCTIONBOUNDARIES false
#define SHORTSTRING_MAXSIZE 256 // Arbitrary.  Affects performance only.  See code which uses it.

char* emptystring="";

uint standard_hash(const char* data, const uint size) {
	uint retval=0;
	for(uint c=0; c<size; c++) retval+=data[c];
	return retval;
}

void String::init() {
	if(DEBUG_FUNCTIONBOUNDARIES) printf("String::init() beginning.\n");
	shortstring=NULL;
	shortstringlength=0;
	mainhead=NULL;
	maintail=NULL;
	length=0;
	iscompacted=true;
}

String::String() {
	init();
}

String::String(const char* newstring) {
	init();
	length=pdfc_strlen(newstring);
	mainhead=maintail=new SFPointer(new StringFragment(newstring, length));
}

String::String(const char* newstring, const uint newlength) {
	init();
	length=newlength;
	mainhead=maintail=new SFPointer(new StringFragment(newstring, length));
}

String::String(const BSTR newstring) {
	init();
/* A BSTR is a pointer to a counted unicode string.  The counted string consists of a 4 byte little endian
count (of bytes) followed by count/2 characters (characters are 2 bytes each).  In addition, Microsoft's
software breaks if the unicode string is not followed by two null bytes, even though this "null terminator"
is completely unnecessary, so this library will append those nulls when it generates BSTRs.  The point of
generating the BSTRs is, after all, to be compatible with Microsoft.  The null terminator bytes are not
included in the count.  The BSTR (the pointer) points to the beginning of the string, not to the count
that precedes the string.
*/
	char* s;
	char* p=(char*)newstring;
	if((*((uint*)(p-4)))%2==1) throw new Err(ESTRINGCLASS|EARGOUTOFRANGE); // BSTR byte counts are always even.
	length=(*((uint*)(p-4)))/2; // Extract the character count.
	s=new char[length+1]; // Including one for null terminator.
	if(s==NULL) throw new Err(ESYS_OUTOFMEM);
	for(uint c=0; c<length; c++) s[c]=p[c*2]; // Copy all the low bytes (ascii compatible characters).
	s[length]='\0';
	(*this)=s;
	delete [] s;
}

String::String(uint num, const uint base) {
	init();
	throw new Err(ESTRINGCLASS|ENOTIMPLEMENTED, "String::String(uint, uint) not implemented yet.\n"); // This function isn't done yet (and needs to be fixed to deal with fragmented strings anyway).
	if((base<2)||(base>36)) { // 2 is the minimal base for a positional
		// number system, and 36 is the maximum base expressible with decimal digits and the English alphabet.
		throw new Err(ESTRINGCLASS|EARGOUTOFRANGE);
	}
	String temp;
	uint modulus, digit;
	modulus=num%base;
	digit=num-modulus;
	if(digit<10) digit=digit|(char)0x30; // Produce ASCII versions of digits 0-9.
	else {
		if(digit<36) digit=(digit-9)|(char)0x40; // Produce ASCII version of digits A-Z.
		else throw new Err(ESTRINGCLASS|EINTERNALERROR);
	}
	temp.append((char*)(&digit), 1);
	num=modulus;

	(*this)=temp;
	// More to come...
}

String::String(const String& newstring) {
	init();
	length=newstring.length;
	mainhead=maintail=new SFPointer(newstring.mainhead);
	iscompacted=false;
	if(newstring.shortstringlength!=0) {
		mainhead->next=maintail=new SFPointer(new StringFragment(newstring.shortstring, newstring.shortstringlength));
		maintail->prev=mainhead;
	}
}


String::~String() {
	if(DEBUG_FUNCTIONBOUNDARIES) printf("String::~String() beginning.\n");
	if(shortstring!=NULL) delete [] shortstring;
	if(mainhead!=NULL) mainhead->unreference();
}

void String::operator=(const String& newstring) {
	if(DEBUG_FUNCTIONBOUNDARIES) printf("String::operator=(const String&) beginning.\n");
	init();
	length=newstring.length;
	mainhead=maintail=new SFPointer(newstring.mainhead);
	iscompacted=false;
	if(newstring.shortstringlength!=0) {
		mainhead->next=maintail=new SFPointer(new StringFragment(newstring.shortstring, newstring.shortstringlength));
		maintail->prev=mainhead;
	}
}

void String::operator=(const char* newstring) {
	if(DEBUG_FUNCTIONBOUNDARIES) printf("String::operator=(const char*) beginning.\n");
	init();
	length=pdfc_strlen(newstring);
	mainhead=maintail=new SFPointer(new StringFragment(newstring, length));
}

bool String::equals(const char* reference, const uint reflength) {
	if(DEBUG_FUNCTIONBOUNDARIES) printf("String::equals(const char*, const uint) beginning.\n");
	if(length!=reflength) return false;
	compact();
	char* s=const_cast<char*>(getrawstring());
	//for(uint c=0; c<length; c++) if(s[c]!=reference[c]) return false;
	//return true;
	return (strncmp(s, reference, length)==0);
}

bool String::operator==(const String& reference) {
	if(DEBUG_FUNCTIONBOUNDARIES) printf("String::operator==(const String&) beginning.\n");
	if(length!=reference.getlength()) return false; // Different length strings can't be equal.
	const_cast<String&>(*this).compact();
	char* s=const_cast<char*>(getrawstring());
	const char* rawref=const_cast<String&>(reference).getrawstring();
	// OLD: for(uint c=0; c<length; c++) if(s[c]!=rawref[c]) return false; // Different chars in string.
	//return true;
	return (strncmp(s, rawref, length)==0);
}

bool String::operator==(char* reference) {
	if(DEBUG_FUNCTIONBOUNDARIES) printf("String::operator==(char*) beginning.\n");
	if(length!=pdfc_strlen(reference)) return false;
	compact();
	char* s=const_cast<char*>(getrawstring());
	//for(uint c=0; c<length; c++) if(s[c]!=reference[c]) return false;
	//return true;
	return (strncmp(s, reference, length)==0);
}

bool String::operator!=(String& reference) {
	if(DEBUG_FUNCTIONBOUNDARIES) printf("String::operator!=(String&) beginning.\n");
	if(length!=reference.getlength()) return true; // Different length strings can't be equal.
	compact();
	char* s=const_cast<char*>(getrawstring());
	const char* rawref=reference.getrawstring();
	//for(uint c=0; c<length; c++) if(s[c]!=rawref[c]) return true; // Different chars in string.
	//return false;
	return (strncmp(s, rawref, length)!=0);
}

bool String::operator!=(char* reference) {
	if(DEBUG_FUNCTIONBOUNDARIES) printf("String::operator!=(char*) beginning.\n");
	if(length!=pdfc_strlen(reference)) return true;
	compact();
	char* s=const_cast<char*>(getrawstring());
	//for(uint c=0; c<length; c++) if(s[c]!=reference[c]) return true;
	//return false;
	return (strncmp(s, reference, length)!=0);
}

bool String::operator>(String& reference) {
	if(DEBUG_FUNCTIONBOUNDARIES) printf("String::operator>(String&) beginning.\n");
	compact();
	char* s=const_cast<char*>(getrawstring());
	uint lesserlength=reference.getlength()<length?reference.getlength():length;
	const char* rawref=reference.getrawstring();
	for(uint c=0; c<lesserlength; c++) {
		char sc=s[c];
		char rc=rawref[c];
		if(sc>rc) return true;
		else if(sc<rc) return false;
	}
	// All chars compared were identical.
	if(length>reference.getlength()) return true; // String with more chars is greater.
	return false; // This string must be either equial to or lesser than reference.
}

bool String::operator<(String& reference) {
	if(DEBUG_FUNCTIONBOUNDARIES) printf("String::operator<(String&) beginning.\n");
	compact();
	char* s=const_cast<char*>(getrawstring());
	uint lesserlength=reference.getlength()<length?reference.getlength():length;
	const char* rawref=reference.getrawstring();
	for(uint c=0; c<lesserlength; c++) {
		char sc=s[c];
		char rc=rawref[c];
		if(sc<rc) return true;
		else if(sc>rc) return false;
	}
	// All chars compared were identical.
	if(length<reference.getlength()) return true; // String with less chars is lesser.
	return false; // This string must be either equial to or greater than reference.
}

bool String::isBinary() { // Note to Steve: this function is illogical, and should be removed.  If it returns
	// true, the string is guaranteed to be non-ascii (poorly named as "binary"), but if it returns false, the
	// string might still be binary.  In addition, even if it WERE possible to implement the intended semantics
	// (which it's not), this function still shouldn't be used.  Don't ever rely on a binary/ascii distinction.
	compact();
	char* s=const_cast<char*>(getrawstring());

	uint i; // Needs to be uint to match variable "length".
 
	for(i=0; i<length; i++) {
		if( (s[i] < 0x20) && (s[i] != '\n') && (s[i] != '\r')) {
			return true;
		}
	}
	return false;
} 

void String::operator+=(const String& reference) {
	append(reference);
}

void String::operator+=(const char* reference) {
	append(reference);
}

inline void String::globshortstring() {
	if(DEBUG_FUNCTIONBOUNDARIES) printf("String::globshortstring() beginning.\n");
	if(shortstringlength==0) return; // There's no short string to glob.
	iscompacted=false;
	SFPointer* newend=new SFPointer(new StringFragment(shortstring, shortstringlength));
	if(mainhead==NULL) mainhead=newend;
	else maintail->next=newend; // Link previous end element to newend.
	maintail=newend;
	shortstringlength=0;
}

char* String::compactrecursively(char* cp, SFPointer* stepper) {
	while(stepper!=NULL) {
		if(stepper->p_sfp!=NULL) {
			cp=compactrecursively(cp, stepper->p_sfp);
		} else if(stepper->p_sf!=NULL) {
			memcpy(cp, stepper->p_sf->getrawstring(), stepper->p_sf->getlength());
			cp+=stepper->p_sf->getlength();
		}
		stepper=stepper->next;
	}
	return cp;
}

void String::compact() {
	if(DEBUG_FUNCTIONBOUNDARIES) printf("String::compact() beginning.\n");
	if(iscompacted) {
		if(DEBUG_FUNCTIONBOUNDARIES) printf("String::compact(): string is already compacted.\n");
		return;
	}
	globshortstring();
	SFPointer* newstring=new SFPointer(new StringFragment(length));
	char* p=const_cast<char*>(newstring->p_sf->getrawstring());
	p=compactrecursively(p, mainhead);
	mainhead->unreference();
	mainhead=maintail=newstring;
	iscompacted=true;
}

void String::append(const String& newsubstring) {
	if(DEBUG_FUNCTIONBOUNDARIES) printf("String::append(const String&) beginning.\n");
	if(newsubstring.length==0) return; // Appending an empty string does nothing.
	if(length==0) { // Appending any string to an empty string is the same as an assignment.
		(*this)=newsubstring;
		return;
	}
	iscompacted=false;
	globshortstring();
	uint newsubstringlength=newsubstring.getlength();
	length+=newsubstringlength;
	SFPointer* newend=new SFPointer(newsubstring.mainhead);
	if(newsubstring.shortstringlength!=0) {
		newend->next=new SFPointer(new StringFragment(newsubstring.shortstring, newsubstring.shortstringlength));
	}
	if(mainhead==NULL) mainhead=newend;
	else maintail->next=newend; // Link previous end element to newend.
	maintail=(newend->next)==NULL?newend:(newend->next);
}

void String::append(const char* newsubstring) {
	uint newsubstringlength=pdfc_strlen(newsubstring);
	append(newsubstring, newsubstringlength);
}

void String::append(const char* newsubstring, const uint newsubstringlength) {
	// This function gets some _serious_ exercise in PDFC.
	if(DEBUG_FUNCTIONBOUNDARIES) printf("String::append(const char*, const uint) beginning.\n");
	if(newsubstringlength==0) {
		if(DEBUG_PRINTALLOCATIONS) printf("Appending empty string.\n");
		return;
	}
	if(length==0) {
		if(DEBUG_PRINTALLOCATIONS) printf("Appending TO an empty string.\n");
		// This is identical to String::String(const char*, const uint).
		init();
		length=newsubstringlength;
		mainhead=maintail=new SFPointer(new StringFragment(newsubstring, length));
		return;
	}
	iscompacted=false;
	length+=newsubstringlength;
	if(newsubstringlength<SHORTSTRING_MAXSIZE-shortstringlength) { // New substring will fit in the buffer.
		if(DEBUG_PRINTALLOCATIONS) printf("Appending %d bytes, and it fits in the shortstring.\n", newsubstringlength);
		if(shortstring==NULL) {
			if(DEBUG_PRINTALLOCATIONS) printf("Allocating a new shortstring.\n");
			shortstring=new char[SHORTSTRING_MAXSIZE]; // Buffer is now actually needed, so it's allocated.
		}
		memcpy(shortstring+shortstringlength, newsubstring, newsubstringlength);
		shortstringlength+=newsubstringlength;
	} else { // It won't fit.
		if(DEBUG_PRINTALLOCATIONS) printf("Appending %d bytes, and it DOESN'T fit in the shortstring.\n", newsubstringlength);
		globshortstring();
		SFPointer* newend=new SFPointer(new StringFragment(newsubstring, newsubstringlength));
		if(mainhead==NULL) mainhead=newend;
		else maintail->next=newend; // Link previous end element to newend.
		maintail=newend;		
	}
}

void String::prepend(const String& newsubstring) {
	if(DEBUG_FUNCTIONBOUNDARIES) printf("String::prepend(const String&) beginning.\n");
	iscompacted=false;
	(*this)=newsubstring+(*this);
}

uint String::replace(const String oldstring, const String newstring) { // Replace oldstring with newstring in this string.
/* Each char in this string is compared with the first char in oldstring.  If they match, the substring
of this string at the current char being tested, with the length of oldstring, is compared with oldstring.
If they match, newstring is copied to the current position in a buffer.  Otherwise, the current char in
this string is copied to the buffer, and testing proceeds with the next char in this string.
*/
	throw new Err(ESTRINGCLASS|ENOTIMPLEMENTED, "String::replace(String, String) not implemented yet.\n"); // This function needs to be updated to work with fragmented strings.
/*
	if(oldstring.length==0) return 0; // No replacements necessary.
	uint rcount=0; // Counts number of replacements performed.
	uint c=0; // Generic counter variable.
	char* oldp=oldstring.s;
	char* newp=newstring.s;
	char* thisp=s;
	char* thisend=s+length;
	const uint& olen=oldstring.length;
	const uint& nlen=newstring.length;
	uint maxsize=(nlen>olen)?nlen*(length/olen+1):length; // If nlen isn't greater than olen, then the
		// replacement can't increase this string size.  If it is greater, then the worst-case scenario is
		// this string is a repeating sequence of oldstring.  Thus maxsize is the maximum new string size.
		// 1 is added to length/olen to (over)compensate for a remainder.
	char* buffer=new char[maxsize];
	uint bufsize=0; // Current number of characters copied into the buffer.
	char* bufp=buffer; // thisp, and bufp will be used to step through their respective strings.
	while(thisp<thisend) { // Step through this string.
		if((*thisp==*oldp)&&((uint)(thisp+olen)<=(uint)thisend)) { // Character matches first character
			// of oldstring, and there are enough remaining characters that a full oldstring match is possible.
			for(c=0; c<olen; c++) { // Check whether the rest of the characters match.
				if(thisp[c]!=oldp[c]) break; // Differing character found.
			}
			if(c==olen) { // All characters matched.
				for(c=0; c<nlen; c++) { // Copy newstring to the buffer.
					*bufp=newp[c];
					bufp++;
				}
				bufsize+=nlen;
				thisp+=olen;
				rcount++;
			} else { // All characters didn't match.  Copy character to buffer and continue.
				*bufp=*thisp;
				bufp++; thisp++; bufsize++;
			}
		} else { // Character didn't match.  Copy it to buffer and continue.
			*bufp=*thisp;
			bufp++; thisp++; bufsize++;
		}
	}
	if(bufsize>maxsize) throw new Err(ESTRINGCLASS|EINTERNALERROR, "String.replace() overran an internal buffer.");
	(*this)=String(buffer, bufsize);
	delete [] buffer;
	return rcount;
*/
}

uint String::replace(const char oldchar, const char newchar) {
	compact();
	char* s=const_cast<char*>(getrawstring());
	uint counter=0;
	for(uint c=0; c<length; c++) if(s[c]==oldchar) {
		s[c]=newchar;
		counter++;
	}
	return counter;
}

String String::operator+(const String &reference) const {
	if(DEBUG_FUNCTIONBOUNDARIES) printf("String::operator+(const String&) beginning.\n");
	String retval=*this;
	retval.append(reference);
	return retval;
}

String String::operator+(const char* reference) const {
	if(DEBUG_FUNCTIONBOUNDARIES) printf("String::operator+(const char*) beginning.\n");
	String retval=*this;
	retval.append(reference);
	return retval;
}

uint String::atoi(const uint base) {
	compact();
	char* s=const_cast<char*>(getrawstring());
	if((base<2)||(base>36)) { // 2 is the minimal base for a positional
		// number system, and 36 is the maximum base expressible with decimal digits and the English alphabet.
		throw new Err(ESTRINGCLASS|EARGOUTOFRANGE);
	}
	uint multiplier=1;
	uint accumulator=0;
	uint oldacc;
	for(uint c=length-1; ((int)c)!=-1; c--) { // Convert chars to unit values, multiply by positions, and accumulate.
		uint thechar=(uint)(s[c]);
		if((thechar>(uint)0x2F)&&(thechar<(uint)0x3A)) { // Digits 0 to 9.
			thechar=thechar&0xF; // Mask off upper four bits, leaving values 0 to 9.
		} else if(((thechar>0x40)&&(thechar<0x5B))||((thechar>0x60)&&(thechar<0x7B))) { // A to Z and a to z.
			thechar=thechar&0x1F; // Mask off upper three bits, leaving values 1 to 26.
			thechar+=9; // Add 9, adjusting values to 10 to 35.
		} else {
			throw new Err(ESTRINGCLASS_INVALIDNUMBERSTRING);
		}
		if(thechar>=base) {
			throw new Err(ESTRINGCLASS_INVALIDNUMBERSTRING);
		}
		oldacc=accumulator;
		accumulator+=thechar*multiplier;
		if(oldacc>accumulator) {
			throw new Err(ESTRINGCLASS_ATOIOVERFLOW);
		}
		multiplier*=base;
	}
	return accumulator;
}

char* String::nullterm() {
	if(DEBUG_FUNCTIONBOUNDARIES) printf("String::nullterm() beginning.\n");
	compact();
	if(DEBUG_PRINTALLOCATIONS) printf("Allocating %d bytes in nullterm().\n", length+1);
	char* retval=new char[length+1]; // Leave room for null terminator.
	memcpy(retval, getrawstring(), length);
	retval[length]='\0'; // Null terminator.
	return retval;
}

uint String::getlength() const {
	return length;
}

void String::reduceLengthTo(const uint newLength) {
	if(DEBUG_FUNCTIONBOUNDARIES) printf("String::reduceLengthTo(const uint) beginning.\n");
	if(newLength>length) throw new Err(ESTRINGCLASS|EARGOUTOFRANGE, "Increasing string length like this is nonsensical.  Steve's code must be broken.\n");
	if(newLength==length) return;
	(*this)=getsubstring(0, newLength-1); // LAME HACK.  Optimize this by completing the code below!
/*	uint deltaremaining=length-newLength;
	if(deltaremaining<=shortstringlength) { // This is the simple condition.
		shortstringlength-=deltaremaining;
		length-=deltaremaining;
		return;
	}
	// This is the hard part.
	SFPointer* newend=maintail;
	uint newendlength;
	while((newendlength=newend->getlength())<=deltaremaining) {
		deltaremaining-=newendlength;
		newend=newend->prev;
	}
	if(newend->next!=NULL) { // Whack off the extra stuff.
		newend->next->prev=NULL; // Prevent the whack from nailing the entire list.
		newend->next->unreference();
		newend->next=NULL;
	}
	if(deltaremaining!=0) {
		// FINISH ME!
		// Remove the remaining stuff from the SFPointer which newend points to...
	}
	length=newLength;
*/
}

char* String::increaseLengthTo(const uint newLength) {
	if(DEBUG_FUNCTIONBOUNDARIES) printf("String::increaseLengthTo(const uint) beginning.\n");
	if(newLength<length) throw new Err(ESTRINGCLASS|EARGOUTOFRANGE, "Reducing string length like this is nonsensical.  Steve's code must be broken.\n");
	if(newLength==length) throw new Err(ESTRINGCLASS|EARGOUTOFRANGE, "String::increaseLengthTo() called with newLength==length.  This isn't supported.\n");
	uint diff=newLength-length;
	globshortstring();
	maintail->next=new SFPointer(new StringFragment(diff));
	length=newLength;
	return const_cast<char*>(maintail->next->p_sf->getrawstring());
}

const char* String::getrawstring() {
	if(DEBUG_FUNCTIONBOUNDARIES) printf("String::getrawstring() beginning.\n");
	compact();
	if(mainhead==NULL) {
		if(shortstring==NULL) return emptystring;
		return shortstring;
	}
	if(mainhead->p_sf==NULL) return emptystring;
	const char* foo=mainhead->p_sf->getrawstring();
	if(foo==NULL) return emptystring;
	return foo;
}

String String::getsubstring(const uint beginoffset) {
	return getsubstring(beginoffset, length-1);
}

String String::getsubstring(const uint beginoffset, const uint endoffset) {
	if((beginoffset>=length)||(endoffset>=length)||(beginoffset>endoffset)) {
		throw new Err(ESTRINGCLASS|EARGOUTOFRANGE);
	}
	compact();
	return String(getrawstring()+beginoffset, endoffset-beginoffset+1);
}

String String::copy() const {
	return String(*this);
}

/* SLOW!
uint String::hash() {
	compact();
	return standard_hash(getrawstring(), length);
}
*/

// Fast:
uint String::hash() { // Return sum of first and last characters.
	if(length==0) return 0;
	if(mainhead==NULL) {
		if(shortstringlength>0) return shortstring[0]+shortstring[shortstringlength-1];
		else return 0;
	}
	compact();
	if(mainhead->p_sf==NULL) return 0;
	const char* c=mainhead->p_sf->getrawstring();
	return c[0]+c[length-1];
}

BSTR String::getBSTR() {
	uint c;
	// See the definition of String::String(BSTR newstring) above for an explanation of BSTRs.
	char* p=new char[length*2+6]; // Add 4 bytes for the count, and 2 for the null padding.
		// Multiply length by 2 since unicode characters are 2 bytes.
	*((uint*)p)=length*2; // Store the byte count for the unicode string.
	p+=4; // Advance the pointer 4 bytes to its final position.
	char* therawstring=const_cast<char*>(getrawstring());
	for(c=0; c<length; c++) { // Copy the ascii string to unicode format.
		p[c*2]=therawstring[c]; // Copy a character.
		p[c*2+1]=(char)0; // Set the second byte of the unicode character to zero.
	}
	p[c*2]=(char)0; // Append the nulls.
	p[c*2+1]=(char)0;
	return (BSTR)p;
}

uint String::gettotalsize() const {
	return sizeof(*this)+length;
}

/*
uint String::serialize(char* buffer) {
	char* tmps=s; // Preserve s.
	s=NULL; // Set s to null so that it will be serialized as null.
	memcpy(buffer, (char*)this, sizeof(*this)); // Shallow copy.
	s=tmps; // Restore s.
	if(length>0) memcpy(buffer+sizeof(*this), s, length); // Deep copy (only if an array exists).
	return sizeof(*this)+length;
}

uint String::deserialize(char* buffer) {
	if(s!=NULL) delete [] s; // Delete old deep data.
	s = NULL;
	memcpy((char*)this, buffer, sizeof(*this)); // Shallow copy.  Note that shallow copy is enough to set the
		// length variable, which allows the deep copy to function properly.
	if(length>0) {
		s=new char[length]; // Allocate memory for deep copy, if necessary.
		memcpy(s, buffer+sizeof(*this), length); // Deep copy (only if an array exists).
	}
	return sizeof(*this)+length;
}
*/

String String::hexencode() {
	char* s=const_cast<char*>(getrawstring());
	char buf;
	char* output=new char[2*length]; // 2 hex characters for every character in this string.
	for(uint c=0; c<length; c++) {
		buf=(s[c]&0xF0)>>4; // Get high nybble of character.
		if(buf>9) buf+=0x7; // Deal with noncontinuity in ASCII chart between 9 and A.
		buf+=0x30; // Convert buf to genuine ASCII character from 0 to 9 or A to F.
		output[2*c]=buf;
		buf=(s[c]&0xF); // Get low nybble of character.
		if(buf>9) buf+=0x7;
		buf+=0x30;
		output[2*c+1]=buf;
	}
	String retval;
	retval.setval(output, 2*length); // Convert output buffer to String object.
	delete [] output;
	return retval;
}

void String::print() {
	throw new Err(ESTRINGCLASS|ENOTIMPLEMENTED, "String::print() not implemented yet.\n");
// Broken!  Update for fragmented strings...
//	fwrite(s, 1, length, stdout);
}

void String::setval(const char* newstring, const uint newlength) {
	if(DEBUG_FUNCTIONBOUNDARIES) printf("String::setval(const char*, const uint) beginning.\n");
	init();
	length=newlength;
	mainhead=maintail=new SFPointer(new StringFragment(newstring, length));
}

int Thash::hash(const String& arg) {return (const_cast<String&>(arg)).hash();}

int Thash::hash(const StringLite& arg) {
	if(arg.length==0) return 0;
	return arg.string[0]+arg.string[arg.length-1];
}

StringFragment::StringFragment(const uint newlength): length(newlength), references(1) {
	if(DEBUG_PRINTALLOCATIONS) printf("Allocating %d bytes in StringFragment::StringFragment(const uint).\n", length+1);
	s=new char[length];
}

StringFragment::StringFragment(const char* news): length(pdfc_strlen(news)), references(1) {
	if(DEBUG_PRINTALLOCATIONS) printf("Allocating %d bytes in StringFragment::StringFragment(const char*).\n", length+1);
	if(news!=NULL) {
		s=new char[length];
		memcpy(s, news, length);
	} else s=NULL;
}

StringFragment::StringFragment(const char* news, const uint newlength): length(newlength), references(1) {
	if(DEBUG_PRINTALLOCATIONS) printf("Allocating %d bytes in StringFragment::StringFragment(const char*, const uint).\n", length+1);
	if(news!=NULL) {
		s=new char[length];
		memcpy(s, news, length);
	} else s=NULL;
}

StringFragment::StringFragment(const StringFragment& frag): length(frag.getlength()), references(1) {
	if(DEBUG_PRINTALLOCATIONS) printf("Allocating %d bytes in StringFragment::StringFragment(const StringFragment&).\n", length+1);
	if(length!=0) {
		s=new char[length];
		memcpy(s, frag.getrawstring(), length);
	} else s=NULL;

}

StringFragment::~StringFragment() {
	if(DEBUG_FUNCTIONBOUNDARIES) printf("StringFragment::~StringFragment() beginning.\n");
	if(s!=NULL) delete [] s;
}

void StringFragment::reference() {
	references++;
}

void StringFragment::unreference() {
	references--;
	if(references<0) throw new Err(666, "Bug in stringclass!  StringFragment::unreference() called with references already equal to zero.\n");
	if(references==0) delete this;
}

uint StringFragment::getlength() const {
	return length;
}

const char* StringFragment::getrawstring() const {
	return s;
}

SFPointer::SFPointer(StringFragment* newsf): references(1), p_sf(newsf), p_sfp(NULL), prev(NULL), next(NULL) {
	if(p_sf!=NULL) p_sf->reference();
}

SFPointer::SFPointer(SFPointer* newsfp): references(1), p_sf(NULL), p_sfp(newsfp), prev(NULL), next(NULL) {
	if(p_sfp!=NULL) p_sfp->reference();
}


//#define PDFC_USE_RECURSIVE_SFPOINTER_DESTRUCTOR

#ifdef PDFC_USE_RECURSIVE_SFPOINTER_DESTRUCTOR
// Recursive version (has a habit of overflowing the stack when I get, oh, way, 43,000 elements in the list!)
SFPointer::~SFPointer() {
	if(p_sf!=NULL) p_sf->unreference();
	if(p_sfp!=NULL) p_sfp->unreference();
	// And now delete the entire list.
	if(prev!=NULL) {
		prev->next=NULL;
		prev->unreference();
	}
	if(next!=NULL) {
		next->prev=NULL;
		next->unreference();
	}
}

#else

// Nonrecursive version.
SFPointer::~SFPointer() {
	if(p_sf!=NULL) p_sf->unreference();
	if(p_sfp!=NULL) p_sfp->unreference();
	// And now delete the entire list.
	// Nonrecursively unreference the preceding elements in the list.
	SFPointer* stepperleader=prev; // Leads the steps through the list.
	SFPointer* steppertrailer; // Stays one step behind the leader.
	while(stepperleader!=NULL) {
		steppertrailer=stepperleader;
		// Grab the pointer before unreferencing the object.
		stepperleader=stepperleader->prev;
		// Isolate the object from the rest of the list so it doesn't try to deallocate the list itself.
		steppertrailer->prev=NULL;
		steppertrailer->next=NULL;
		// And finally, actually unreference the object.
		steppertrailer->unreference();
	}
	// Nonrecursively unreference the following elements in the list.
	stepperleader=next;
	while(stepperleader!=NULL) {
		steppertrailer=stepperleader;
		stepperleader=stepperleader->next;
		steppertrailer->prev=NULL;
		steppertrailer->next=NULL;
		steppertrailer->unreference();
	}
}
#endif

void SFPointer::reference() {
	references++;
}

void SFPointer::unreference() {
	references--;
	if(references<0) throw new Err(666, "Bug in stringclass!  SFPointer::unreference() called with references already equal to zero.\n");
	if(references==0) {
		// This is overflowing the stack...
		// Perhaps use a non-recursive unreference and delete mechanism?
		delete this;
	}
}

uint SFPointer::getlength() const {
	if(p_sf!=NULL) return p_sf->getlength();
	if(p_sfp!=NULL) return p_sfp->getlength()+(p_sfp->next==NULL)?(0):(p_sfp->next->getlength());
	return 0;
}

bool StringLite::operator==(const StringLite& ref) {
	if(ref.length!=length) return false;
	return(strncmp(ref.string, string, length)==0);
}

bool StringLite::operator==(const char* ref) {
	uint reflen=pdfc_strlen(ref);
	if(reflen!=length) return false;
	return(strncmp(ref, string, length)==0);
}

StringLite::StringLite(char* newstring, uint newlength): string(newstring), length(newlength) {}
