// pdfcwrapper.h : Declaration of the Cpdfcwrapper

#ifndef __PDFCWRAPPER_H_
#define __PDFCWRAPPER_H_

#include "resource.h"       // main symbols
#include <asptlb.h>         // Active Server Pages Definitions

#include <stdlib.h>

// Copied blindly from apiTest.cpp
#include "PdfObjects.hpp"
#include "FontReader.hpp"
#include "pdfc_base.h"
#include "pdfc_basicobjects.h"
#include "stringclass.h"
#include "PDFTokenizer.hpp"
#include "ImageReader.hpp"
#include "PsCommands.hpp"

// Copied blindly from cmdline.cpp (and duplicates relative apiTest.cpp removed)
#include "XMLReader.hpp"
#include "PDFReader.hpp"
#include "ObjParser.hpp"
#include "XMLModule_highLevel.hpp"
#include "XMLModule_lowLevel.hpp"

/////////////////////////////////////////////////////////////////////////////
// Cpdfcwrapper
class ATL_NO_VTABLE Cpdfcwrapper : 
	public CComObjectRootEx<CComMultiThreadModel>,
	public CComCoClass<Cpdfcwrapper, &CLSID_pdfcwrapper>,
	public IDispatchImpl<Ipdfcwrapper, &IID_Ipdfcwrapper, &LIBID_LIBPDFCCOMLib>
{
public:
	Cpdfcwrapper()
	{ 
		m_bOnStartPageCalled = FALSE;
		init_pscommands(); // It's really important to do this or stuff will blow up badly.
		
		root=NULL;
		pdfRoot=NULL;
	}

public:

DECLARE_REGISTRY_RESOURCEID(IDR_PDFCWRAPPER)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(Cpdfcwrapper)
	COM_INTERFACE_ENTRY(Ipdfcwrapper)
	COM_INTERFACE_ENTRY(IDispatch)
END_COM_MAP()

// Ipdfcwrapper
public:
	STDMETHOD(xml2pdf)(BSTR infilename, BSTR outfilename);
	STDMETHOD(pdf2xml)(BSTR infilename, BSTR outfilename);
	//Active Server Pages Methods
	STDMETHOD(OnStartPage)(IUnknown* IUnk);
	STDMETHOD(OnEndPage)();

	STDMETHOD(closepath_eofill_and_stroke)(IUnknown** objRef);
	STDMETHOD(closepath_fill_and_stroke)(IUnknown** objRef);
	STDMETHOD(begin_marked_content_with_propertylist)(IUnknown** objRef);
	STDMETHOD(eofill_and_stroke)(IUnknown** objRef);
	STDMETHOD(fill_and_stroke)(IUnknown** objRef);
	STDMETHOD(begin_image)(IUnknown** objRef);
	STDMETHOD(begin_marked_content)(IUnknown** objRef, BSTR name0);
	STDMETHOD(begin_text_object)(IUnknown** objRef);
	STDMETHOD(begin_hiding_undefined_operators)(IUnknown** objRef);
	STDMETHOD(appendbeziercurve)(IUnknown** objRef, double num0, double num1, double num2, double num3, double num4, double num5);
	STDMETHOD(concatenate_CTM_matrix)(IUnknown** objRef, double num0, double num1, double num2, double num3, double num4, double num5);
	STDMETHOD(set_fillcolorspace)(IUnknown** objRef, BSTR name0);
	STDMETHOD(set_strokecolorspace)(IUnknown** objRef, BSTR name0);
	STDMETHOD(set_character_width)(IUnknown** objRef, double num0, double num1);
	STDMETHOD(set_cache_device)(IUnknown** objRef, double num0, double num1, double num2, double num3, double num4, double num5);
	STDMETHOD(execute_xobject)(IUnknown** objRef, BSTR xobject0);
	STDMETHOD(mark_point_with_propertylist)(IUnknown** objRef);
	STDMETHOD(set_dashpattern)(IUnknown** objRef, IUnknown* array0, double num1);
	STDMETHOD(end_image)(IUnknown** objRef);
	STDMETHOD(end_marked_content)(IUnknown** objRef);
	STDMETHOD(end_text_object)(IUnknown** objRef);
	STDMETHOD(end_hiding_undefined_operators)(IUnknown** objRef);
	STDMETHOD(fillpath)(IUnknown** objRef);
	STDMETHOD(fillpath_oddeven)(IUnknown** objRef);
	STDMETHOD(set_grayfilltint)(IUnknown** objRef, double num0);
	STDMETHOD(set_graystroketint)(IUnknown** objRef, double num0);
	STDMETHOD(set_graphicsstate)(IUnknown** objRef, BSTR name0);
	STDMETHOD(closecurrentsubpath)(IUnknown** objRef);
	STDMETHOD(begin_image_data)(IUnknown** objRef);
	STDMETHOD(set_flatness)(IUnknown** objRef, double num0);
	STDMETHOD(set_linecap)(IUnknown** objRef, double num0);
	STDMETHOD(set_linejoin)(IUnknown** objRef, double num0);
	STDMETHOD(set_fillcolorCMYK)(IUnknown** objRef, double num0, double num1, double num2, double num3);
	STDMETHOD(set_strokecolorCMYK)(IUnknown** objRef, double num0, double num1, double num2, double num3);
	STDMETHOD(lineto)(IUnknown** objRef, double num0, double num1);
	STDMETHOD(moveto)(IUnknown** objRef, double num0, double num1);
	STDMETHOD(mark_point)(IUnknown** objRef, BSTR name0);
	STDMETHOD(set_miterlimit)(IUnknown** objRef, double num0);
	STDMETHOD(endpath)(IUnknown** objRef);
	STDMETHOD(newline_and_setspacing_and_show_text_string)(IUnknown** objRef, double num0, double num1, BSTR string2);
	STDMETHOD(newline_and_show_text_string)(IUnknown** objRef, BSTR string0);
	STDMETHOD(exec_postscript)(IUnknown** objRef, BSTR string0);
	STDMETHOD(restore_graphics_state)(IUnknown** objRef);
	STDMETHOD(save_graphics_state)(IUnknown** objRef);
	STDMETHOD(add_rectangle)(IUnknown** objRef, double num0, double num1, double num2, double num3);
	STDMETHOD(set_fillcolorRGB)(IUnknown** objRef, double num0, double num1, double num2);
	STDMETHOD(set_strokecolorRGB)(IUnknown** objRef, double num0, double num1, double num2);
	STDMETHOD(set_colorrenderingintent)(IUnknown** objRef, BSTR name0);
	STDMETHOD(close_and_strokepath)(IUnknown** objRef);
	STDMETHOD(SCN_)(IUnknown** objRef);
	STDMETHOD(scn)(IUnknown** objRef);
	STDMETHOD(set_fillcolor)(IUnknown** objRef);
	STDMETHOD(set_strokecolor)(IUnknown** objRef);
	STDMETHOD(shade)(IUnknown** objRef, double num0);
	STDMETHOD(strokepath)(IUnknown** objRef);
	STDMETHOD(set_character_spacing)(IUnknown** objRef, double num0);
	STDMETHOD(newline)(IUnknown** objRef, double num0, double num1);
	STDMETHOD(newline_and_set_leading)(IUnknown** objRef, double num0, double num1);
	STDMETHOD(set_font_and_size)(IUnknown** objRef, BSTR name0, double num1);
	STDMETHOD(show_text_string)(IUnknown** objRef, BSTR string0);
	STDMETHOD(show_text_string_with_displacements)(IUnknown** objRef, IUnknown* array0);
	STDMETHOD(set_text_leading)(IUnknown** objRef, double num0);
	STDMETHOD(set_text_matrix)(IUnknown** objRef, double num0, double num1, double num2, double num3, double num4, double num5);
	STDMETHOD(newline_with_defaultoffset)(IUnknown** objRef);
	STDMETHOD(set_text_rendering_mode)(IUnknown** objRef, double num0);
	STDMETHOD(set_text_size)(IUnknown** objRef, double num0);
	STDMETHOD(set_word_spacing)(IUnknown** objRef, double num0);
	STDMETHOD(set_horizontal_scaling)(IUnknown** objRef, double num0);
	STDMETHOD(appendbeziercurve_current)(IUnknown** objRef, double num0, double num1, double num2, double num3);
	STDMETHOD(clip)(IUnknown** objRef);
	STDMETHOD(clip_evenodd)(IUnknown** objRef);
	STDMETHOD(set_linewidth)(IUnknown** objRef, double num0);
	STDMETHOD(appendbeziercurve_current_secondversion)(IUnknown** objRef, double num0, double num1, double num2, double num3);
private:
	CComPtr<IRequest> m_piRequest;					//Request Object
	CComPtr<IResponse> m_piResponse;				//Response Object
	CComPtr<ISessionObject> m_piSession;			//Session Object
	CComPtr<IServer> m_piServer;					//Server Object
	CComPtr<IApplicationObject> m_piApplication;	//Application Object
	BOOL m_bOnStartPageCalled;						//OnStartPage successful?

	PObj* root;
	PdfRoot* pdfRoot;
	PDFReader preader;
	ObjParser objParser;
	
};

#endif //__PDFCWRAPPER_H_
